#include "Project.h"




void core_game_loop()
{
 int next = 0;
 int exit = 0;
 int event = 0;

 // We will land here after a successful game loop
 //
 restart:

 init_game_variables();


 // Read high score from file
 //
 #ifndef PLATFORM_WEB
     #ifdef USE_BULLETIN
         if(read_high_score()) {
             sprintf(rep_str, "TOP SCORE: %08d BY %c%c%c          ", flags.high_score, high_init[0], high_init[1], high_init[2]);
             rep_str[54] = 0;
             bulletins[5] = rep_str;
                               }
     #endif
 #endif


 #ifdef SKIP_INTRO
     goto skip_jank;
 #endif


 // Set up bulletin for title block
 //
 #ifndef PLATFORM_WEB
     #ifdef USE_BULLETIN
         bulletin.message = 5;
         bulletin.time_left = -1; // Infinite
         bulletin.enabled = 0;
     #endif
 #endif

 // Stop music if it's still playing
 //
 fade_all_music();


    /// Title block loop ---------------------------------------------------------------------------------------
    //
    do {

        #ifndef MOUSE_IS_PRIMARY
        anims[0] = 1.00;
        update_and_render();

            // Check for gamepad swap
            //
            if(IsKeyDown(KEY_J)) {
                do { update_and_render(); } while(IsKeyDown(KEY_J));
                flags.gamepad = 1;
                                 }

            if(IsKeyDown(KEY_K)) {
                do { update_and_render(); } while(IsKeyDown(KEY_K));
                flags.gamepad = 0;
                                 }


            if(actors[puppet].d_pad[0] && !actors[puppet].d_repeat[0]) {
                if(flags.menu_pos > 0) {
                    flags.menu_pos--;
                    PlaySound(sfx[200]);
                    actors[puppet].d_repeat[0] = 1;
                                       }
                                                                       }

            if(actors[puppet].d_pad[2] && !actors[puppet].d_repeat[2]) {
                if(flags.menu_pos < (MAIN_MENU_OPTIONS - 1)) {
                    flags.menu_pos++;
                    PlaySound(sfx[200]);
                    actors[puppet].d_repeat[2] = 1;
                                                             }
                                                                       }

        if(IsKeyDown(KEY_Z)) { next = 1; }
        if(IsGamepadButtonDown(0, GAMEPAD_BUTTON_RIGHT_FACE_DOWN)) { next = 1; }

        if(next && (!IsKeyDown(KEY_Z)) &&
           !IsGamepadButtonDown(0, GAMEPAD_BUTTON_RIGHT_FACE_DOWN)) { PlaySound(sfx[81]); exit = 1; }

        #else
        open_menu(30);
        event = get_menu_event(30);
        PlaySound(sfx[52]);

        flags.menu_pos = event;
        close_menu(30);
        exit = 1;
        #endif


       } while (!exit);



    // Fade Title out
    //
    flags.tint_col = BLACK;
    flags.tint_str = 0.0;
    flags.tint_velocity = 0.040;
    do {
        update_and_render();
       } while (flags.tint_str < 1.00);


    log(LOG_1, "MAIN MENU RESULT = %d", flags.menu_pos);

    // Evaluate results of menu selections
    //
    switch(flags.menu_pos) {
        case 0: // Play Game
                flags.game_stage = 0;
                flags.tutorial   = 0;
                break;

        case 1: // Tutorial
                flags.game_stage = 1;
                flags.tutorial   = 1;
                break;

        case 2: // Exit game
                return;
                break;
                           }

    #ifdef USE_BULLETIN
        bulletin.enabled = 0;
    #endif


    /// Basic Tutorial Loop ------------------------------------------------------------------- ///
    //
    if(!flags.tutorial_seen && flags.basic_tutorial) {
        // Tutorial Display loop (only on first game of each session)
        //
        next            = 0;
        exit            = 0;
        flags.game_mode = 1;

        do {
            update_and_render();

            if(IsKeyDown(KEY_Z)) { next = 1; }
            if(IsGamepadButtonDown(0, GAMEPAD_BUTTON_RIGHT_FACE_DOWN)) { next = 1; }

            if(next && (!IsKeyDown(KEY_Z)) &&
               !IsGamepadButtonDown(0, GAMEPAD_BUTTON_RIGHT_FACE_DOWN)) { PlaySound(sfx[81]); exit = 1; }

           } while (!exit);


        // Fade Title out
        //
        do {
            anims[1] -= 0.04;
            update_and_render();
           } while (anims[1] > 0.00);

        flags.tutorial_seen = 1;
                                                     }


    if(flags.tutorial) { init_tutorial_variables(); }

    skip_jank:

    next_stage:

    /// Main Game Loop ------------------------------------------------------------------------ ///
    //
    next            = 0;
    exit            = 0;
    flags.game_mode = 2;


    // Start music from beginning
    //
    rewind_music(0);
    fade_music_in(0);


    // Fade Scene in
    //
    flags.tint_col = BLACK;
    flags.tint_str = 1.0;
    flags.tint_velocity = -0.040;
    do {
        update_and_render();
       } while (flags.tint_str > 0.0);

    flags.tint_str = 0.0;
    flags.tint_velocity = 0.0;


    PlaySound(sfx[226]); // PIMP THAT ASS


    while (!flags.game_over && !flags.stage_complete) {

         #ifdef USE_RTMIDI
         if(IsKeyDown(KEY_F7)) {
             do { update_and_render(); } while(IsKeyDown(KEY_F7));
             load_knobs();
                               }
         #endif


        // Check for gamepad swap
        //
        #ifndef MOUSE_IS_PRIMARY
        if(IsKeyDown(KEY_J)) {
            do { update_and_render(); } while(IsKeyDown(KEY_J));
            flags.gamepad = 1;
                             }

        if(IsKeyDown(KEY_K)) {
            do { update_and_render(); } while(IsKeyDown(KEY_K));
            flags.gamepad = 0;
                             }
        #endif

        check_game_specific_logic();

        update_and_render();
                                                      }


    end_game(0);

    goto restart;
}




// Ends game upon time-out.
// Player gets a review of their stats
// Player is then booted to the title screen (vars need to be reset)
//
void end_game(int mode)
{
 int exit        = 0;
 int event       = 0;
 int frame_ticks = 0;

 flags.game_mode = 3;
 camera.rotation = 0.00;
 camera.zoom     = 1.00;

 flags.mosaic          = 0.0;
 flags.mosaic_velocity = 0.00;

 flags.game_speed      = 1.0;
 flags.game_velocity   = 0.0;

 flags.tint_velocity = -0.04;
 flags.tint_col      = BLACK;
 flags.tint_str      = 1.00;


 // Record final summary for game-over screen
 //
 check_summary();


 // Let fade in do its work
 //
 do {
     update_and_render();
    } while(flags.tint_str > 0.0 || actors[puppet].buttons[0]);


 #ifndef MOUSE_IS_PRIMARY
     do {
         update_and_render();
        } while(!actors[puppet].buttons[0] && !actors[puppet].b_repeat[0]);

     PlaySound(sfx[81]);
     flags.show_signal = -1;

     do {
         update_and_render();
        } while(actors[puppet].buttons[0]);

 #else
        open_menu(31);
        event = get_menu_event(31);
        PlaySound(sfx[52]);

        close_menu(31);
        exit = 1;
 #endif // MOUSE_IS_PRIMARY


 // Fade Summary out
 //
 flags.tint_col = BLACK;
 flags.tint_str = 0.0;
 flags.tint_velocity = 0.040;

 do {
     update_and_render();
    } while (flags.tint_str < 1.00);


 /// Uncomment this line to reset the high score
 ///
 ///flags.score = 666; flags.high_score = 600;


#if !defined (PLATFORM_WEB) && defined (USE_HIGH_SCORE)
 if(flags.score[0] > flags.high_score) {
     flags.game_mode      = 4;

     hi_score.selected    = 0;
     hi_score.initials[0] = 0;
     hi_score.initials[1] = 0;
     hi_score.initials[2] = 0;
     hi_score.blink       = 0;
     hi_score.blink_timer = 0;

     do { update_and_render(); } while(IsKeyDown(KEY_SPACE));

     do {
         key = get_initial();

         if(key) {
             hi_score.initials[hi_score.selected] = key;

             // Slots 0 or 1 filled
             //
             if(hi_score.selected < 2) { /*PlaySound(sfx[12]);*/ hi_score.selected++; }

             // All holes filled lol. SAVE THAT SHIT AND CELEBRATE
             //
             else {
                 //PlaySound(sfx[13]);

                 hi_score.selected++;
                 frame_ticks = 0;
                 do {
                     update_and_render();
                     frame_ticks++;
                    } while(frame_ticks < 120);

                 exit = 1;
                  }
                 }

         if(IsKeyPressed(KEY_RIGHT)) { if(hi_score.selected < 2) { hi_score.selected++; } }
         if(IsKeyPressed(KEY_LEFT))  { if(hi_score.selected)     { hi_score.selected--; } }

         update_and_render();
        } while(!exit);

      write_high_score();
                        }
 #endif // PLATFORM_WEB

 return;
}





// NOTE: Draws the top/bottom banners for the title screen
//       This also includes any main menu selections, etc
//
void draw_title_menu(const char *msg)
{
 int     i          = 0;
 int     scaling    = 3;                 // font scaling
 int     bar_height = 0;

 float   start_y    = 0.0;
 float   hue        = 0.00;
 float   alpha      = 0.00;
 float   y_spacing  = 0.00;
 float   f_spacing  = 10.0;              // font spacing
 float   y_pos      = 0.00;

 Color text_color   = BLANK;
 Color bar_color    = BLANK;

 EndMode2D();


 // Bar color and alpha is animated
 //
 hue       = MAIN_MENU_BAR_COLOR + sin(TO_RADIANS(anims[4])) * MAIN_MENU_BAR_RANGE;
 alpha     = (1.0 - MAIN_MENU_BAR_ALPHA) + sin(TO_RADIANS(anims[4])) * MAIN_MENU_BAR_ALPHA;
 bar_color = ColorFromHSV(hue, 1.0, 1.0);


 // Option spacing and bar height are automatically calculated
 //
 y_spacing  = SCREEN_H / MAIN_MENU_BAR_SPACING;
 bar_height = SCREEN_H / MAIN_MENU_BAR_SIZE;
 start_y    = (SCREEN_H * 0.96) - (MAIN_MENU_OPTIONS * y_spacing);


 for(i=0; i<MAIN_MENU_OPTIONS; i++) {
     y_pos = start_y + (y_spacing * i);
     if(flags.menu_pos == i) {
         text_color = WHITE;
         DrawRectangle(SCREEN_W / 4, y_pos, SCREEN_W / 2, bar_height, Fade(bar_color, alpha));
                             }
     else {
         text_color = GRAY;
         DrawRectangle(SCREEN_W / 4, y_pos, SCREEN_W / 2, bar_height, Fade(BLACK, 0.50));
          }

     justify_text_xy(main_options[i], (SCREEN_W / 2) + 4, y_pos + 14, title_font, BLACK, scaling, f_spacing);
     justify_text(main_options[i], y_pos + 10, title_font, text_color, scaling, f_spacing);
                                    }


 /// bonus credits for this project (if any)
 ///
 //justify_text("...", SCREEN_H - 60, title_font, YELLOW, 1, 1);
 //justify_text("...", SCREEN_H - 35, title_font, YELLOW, 1, 1);

 BeginMode2D(camera);

 return;
}






void draw_hud()
{
/*
 int start_y    = 0;
 Vector3 jitter = { 0 };
 Vector2 len_a  = { 0 };
 Vector2 len_b  = { 0 };
 Color color    = BLANK;
 char strang[80];



 // Uncomment this for top HUD
 //
 if(!HUD_LOCATION) {
     DrawRectangleGradientV(0, 3, SCREEN_W, HUD_HEIGHT, HUD_GRADIENT_1, HUD_GRADIENT_2);
     start_y = HUD_TEXT_START;
                   }

 else {
     DrawRectangleGradientV(0, SCREEN_H - HUD_HEIGHT, SCREEN_W, HUD_HEIGHT, HUD_GRADIENT_2, HUD_GRADIENT_1);
     start_y = SCREEN_H - ((HUD_HEIGHT / 2) - HUD_TEXT_START);
      }


 sprintf(strang, "%04d", flags.sum_launches);
 DrawTextEx(hud_font, "LAUNCHES", (Vector2){10, (float)start_y}, hud_font.baseSize * HUD_TEXT_SCALE, HUD_TEXT_SCALE, YELLOW);
 DrawTextEx(hud_font, strang, (Vector2){230, (float)start_y}, hud_font.baseSize * HUD_TEXT_SCALE, HUD_TEXT_SCALE, WHITE);


 // Score display
 // If score shake is active, shift position randomly and change color
 //
 sprintf(strang, "SCORE %08d", flags.score);
 len_a = MeasureTextEx(hud_font, strang, hud_font.baseSize * HUD_TEXT_SCALE, HUD_TEXT_SCALE);
 sprintf(strang, "%08d", flags.score);
 len_b = MeasureTextEx(hud_font, strang, hud_font.baseSize * HUD_TEXT_SCALE, HUD_TEXT_SCALE);

 DrawTextEx(hud_font, "SCORE", (Vector2){SCREEN_W - len_a.x - 10, (float)start_y}, hud_font.baseSize * HUD_TEXT_SCALE, HUD_TEXT_SCALE, YELLOW);

 if(!flags.score_shake) {
     DrawTextEx(hud_font, strang, (Vector2){SCREEN_W - len_b.x - 10, (float)start_y}, hud_font.baseSize * HUD_TEXT_SCALE, HUD_TEXT_SCALE, WHITE);
                        }
 else {
     jitter.x = -5.0 + ((float)quick_rand(100) / 10.0);
     jitter.y = -5.0 + ((float)quick_rand(100) / 10.0);

     // Color fades from a fugly pink back to white over time
     //
     jitter.z = rescale(flags.score_shake, 0, 180, 0.0, 1.0);
     color    = grab_gradient(WHITE, SCORE_PINK, 0.0, jitter.z);
     DrawTextEx(hud_font, strang, (Vector2){SCREEN_W - len_b.x - 10 + jitter.x, start_y + jitter.y}, hud_font.baseSize * HUD_TEXT_SCALE, HUD_TEXT_SCALE, color);
      }

 if(flags.debug) {
     sprintf(strang, "T:%02d", flags.total_actors);
     DrawTextEx(hud_font, strang, (Vector2){360, (float)start_y}, hud_font.baseSize * HUD_TEXT_SCALE, HUD_TEXT_SCALE, CHILL_CYAN);
                 }
*/

 draw_hud_manifest();

 if(flags.show_notice) { draw_notice(); }

 return;
}





// NOTE: Control hints will be drawn at the opposite end of the screen from the HUD.
//
void draw_control_hints(int mode)
{
 Vector2 len_h       = { 0 };
 Vector2 len_a       = { 0 };
 Vector2 len_b       = { 0 };
 Vector2 dest_text   = { 0 };
 Vector2 dest_shadow = { 0 };

 float y_start = 0.0;

 len_h = MeasureTextEx(controls_font, "A", controls_font.baseSize * CONTROLS_TEXT_SCALE, CONTROLS_TEXT_SPACING);

 // Bottom of screen
 if(!HUD_LOCATION) {
     y_start = SCREEN_H - len_h.y - 9.0;
                   }
 // Top of screen
 else {
     y_start = 9.0;
      }

 EndMode2D();

 // KEYBOARD
 //
 if(!flags.gamepad) {
     if(!mode) {
         len_a = MeasureTextEx(controls_font, menu_keyboard_tips[0], controls_font.baseSize * CONTROLS_TEXT_SCALE, CONTROLS_TEXT_SPACING);
         len_b = MeasureTextEx(controls_font, menu_keyboard_tips[1], controls_font.baseSize * CONTROLS_TEXT_SCALE, CONTROLS_TEXT_SPACING);

         dest_text.x = 9.0;
         dest_text.y = y_start;
         dest_shadow.x = dest_text.x + CONTROLS_TEXT_SCALE;
         dest_shadow.y = dest_text.y + CONTROLS_TEXT_SCALE;
         DrawTextEx(controls_font, menu_keyboard_tips[0], dest_shadow, controls_font.baseSize * CONTROLS_TEXT_SCALE, CONTROLS_TEXT_SPACING, Fade(CONTROLS_COLOR_2, 0.75));
         DrawTextEx(controls_font, menu_keyboard_tips[0], dest_text,   controls_font.baseSize * CONTROLS_TEXT_SCALE, CONTROLS_TEXT_SPACING, Fade(CONTROLS_COLOR_1, 1.0));

         dest_text.x = SCREEN_W - 9.0 - len_b.x;
         dest_text.y = y_start;
         dest_shadow.x = dest_text.x + CONTROLS_TEXT_SCALE;
         dest_shadow.y = dest_text.y + CONTROLS_TEXT_SCALE;
         DrawTextEx(controls_font, menu_keyboard_tips[1], dest_shadow, controls_font.baseSize * CONTROLS_TEXT_SCALE, CONTROLS_TEXT_SPACING, Fade(CONTROLS_COLOR_2, 0.75));
         DrawTextEx(controls_font, menu_keyboard_tips[1], dest_text,   controls_font.baseSize * CONTROLS_TEXT_SCALE, CONTROLS_TEXT_SPACING, Fade(CONTROLS_COLOR_1, 1.0));
               }
     else {
         len_a = MeasureTextEx(controls_font, game_keyboard_tips[0], controls_font.baseSize * CONTROLS_TEXT_SCALE, CONTROLS_TEXT_SPACING);
         len_b = MeasureTextEx(controls_font, game_keyboard_tips[1], controls_font.baseSize * CONTROLS_TEXT_SCALE, CONTROLS_TEXT_SPACING);

         dest_text.x = 9.0;
         dest_text.y = y_start;
         dest_shadow.x = dest_text.x + CONTROLS_TEXT_SCALE;
         dest_shadow.y = dest_text.y + CONTROLS_TEXT_SCALE;
         DrawTextEx(controls_font, game_keyboard_tips[0], dest_shadow, controls_font.baseSize * CONTROLS_TEXT_SCALE, CONTROLS_TEXT_SPACING, Fade(CONTROLS_COLOR_2, 0.75));
         DrawTextEx(controls_font, game_keyboard_tips[0], dest_text,   controls_font.baseSize * CONTROLS_TEXT_SCALE, CONTROLS_TEXT_SPACING, Fade(CONTROLS_COLOR_1, 1.0));

         dest_text.x = SCREEN_W - 9.0 - len_b.x;
         dest_text.y = y_start;
         dest_shadow.x = dest_text.x + CONTROLS_TEXT_SCALE;
         dest_shadow.y = dest_text.y + CONTROLS_TEXT_SCALE;
         DrawTextEx(controls_font, game_keyboard_tips[1], dest_shadow, controls_font.baseSize * CONTROLS_TEXT_SCALE, CONTROLS_TEXT_SPACING, Fade(CONTROLS_COLOR_2, 0.75));
         DrawTextEx(controls_font, game_keyboard_tips[1], dest_text,   controls_font.baseSize * CONTROLS_TEXT_SCALE, CONTROLS_TEXT_SPACING, Fade(CONTROLS_COLOR_1, 1.0));

          }
                    }

 // GAMEPAD
 //
 else {
     if(!mode) {
         len_a = MeasureTextEx(controls_font, menu_gamepad_tips[0], controls_font.baseSize * CONTROLS_TEXT_SCALE, CONTROLS_TEXT_SPACING);
         len_b = MeasureTextEx(controls_font, menu_gamepad_tips[1], controls_font.baseSize * CONTROLS_TEXT_SCALE, CONTROLS_TEXT_SPACING);

         dest_text.x = 9.0;
         dest_text.y = y_start;
         dest_shadow.x = dest_text.x + CONTROLS_TEXT_SCALE;
         dest_shadow.y = dest_text.y + CONTROLS_TEXT_SCALE;
         DrawTextEx(controls_font, menu_gamepad_tips[0], dest_shadow, controls_font.baseSize * CONTROLS_TEXT_SCALE, CONTROLS_TEXT_SPACING, Fade(CONTROLS_COLOR_2, 0.75));
         DrawTextEx(controls_font, menu_gamepad_tips[0], dest_text,   controls_font.baseSize * CONTROLS_TEXT_SCALE, CONTROLS_TEXT_SPACING, Fade(CONTROLS_COLOR_1, 1.0));

         dest_text.x = SCREEN_W - 9.0 - len_b.x;
         dest_text.y = y_start;
         dest_shadow.x = dest_text.x + CONTROLS_TEXT_SCALE;
         dest_shadow.y = dest_text.y + CONTROLS_TEXT_SCALE;
         DrawTextEx(controls_font, menu_gamepad_tips[1], dest_shadow, controls_font.baseSize * CONTROLS_TEXT_SCALE, CONTROLS_TEXT_SPACING, Fade(CONTROLS_COLOR_2, 0.75));
         DrawTextEx(controls_font, menu_gamepad_tips[1], dest_text,   controls_font.baseSize * CONTROLS_TEXT_SCALE, CONTROLS_TEXT_SPACING, Fade(CONTROLS_COLOR_1, 1.0));
               }
     else {
         len_a = MeasureTextEx(controls_font, game_gamepad_tips[0], controls_font.baseSize * CONTROLS_TEXT_SCALE, CONTROLS_TEXT_SPACING);
         len_b = MeasureTextEx(controls_font, game_gamepad_tips[1], controls_font.baseSize * CONTROLS_TEXT_SCALE, CONTROLS_TEXT_SPACING);

         dest_text.x = 9.0;
         dest_text.y = y_start;
         dest_shadow.x = dest_text.x + CONTROLS_TEXT_SCALE;
         dest_shadow.y = dest_text.y + CONTROLS_TEXT_SCALE;
         DrawTextEx(controls_font, game_gamepad_tips[0], dest_shadow, controls_font.baseSize * CONTROLS_TEXT_SCALE, CONTROLS_TEXT_SPACING, Fade(CONTROLS_COLOR_2, 0.75));
         DrawTextEx(controls_font, game_gamepad_tips[0], dest_text,   controls_font.baseSize * CONTROLS_TEXT_SCALE, CONTROLS_TEXT_SPACING, Fade(CONTROLS_COLOR_1, 1.0));

         dest_text.x = SCREEN_W - 9.0 - len_b.x;
         dest_text.y = y_start;
         dest_shadow.x = dest_text.x + CONTROLS_TEXT_SCALE;
         dest_shadow.y = dest_text.y + CONTROLS_TEXT_SCALE;
         DrawTextEx(controls_font, game_gamepad_tips[1], dest_shadow, controls_font.baseSize * CONTROLS_TEXT_SCALE, CONTROLS_TEXT_SPACING, Fade(CONTROLS_COLOR_2, 0.75));
         DrawTextEx(controls_font, game_gamepad_tips[1], dest_text,   controls_font.baseSize * CONTROLS_TEXT_SCALE, CONTROLS_TEXT_SPACING, Fade(CONTROLS_COLOR_1, 1.0));
          }
      }

 BeginMode2D(camera);

 return;
}




// NOTE: Draws the actual title screen, with animations and whatnot
//
void draw_title()
{
 float alpha       = 0.0;
 float y_shift     = 0.0;
 float base_y      = 30.0;
 float emoji_scale = 1.0;
 Vector2 pos       = { 0.0, 0.0 };

 DrawTextureEx(tex_title_bg, pos, 0.0, 3.0, WHITE);


 BeginShaderMode(edge_fade);
     tex_blit(tex_stripes, anims[8], 0, 0, base_y + 140, SCREEN_W, 100, 0.0, 2.0, Fade(TOOLTIP_BLUE, 0.50));
 EndShaderMode();

 // Draw title
 //
 pos.x = (SCREEN_W / 2) - ((tex_title.width * 2.0) / 2.0);
 DrawTextureEx(tex_title, (Vector2){pos.x, base_y}, 0.0, 2.0, WHITE);

 // Draw sub-title
 //
 justify_text_xy("FROM  THE  WILD  BEYOND", (SCREEN_W / 2) + 4, base_y + 174, title_font, TOOLTIP_BLUE, 3.0, 30.0);
 justify_text("FROM  THE  WILD  BEYOND", base_y + 170, title_font, WHITE, 3.0, 30.0);

 return;
}




// TODO: Have a summary font pointer that's assigned to an existing font
// TODO: Sum_start should be auto-calculated based off of num items + size + spacing total
//       subtracting area for title, score, and "press z to continue" message space

// Draws game over score summary
//
void draw_summary(int mode)
{
 int i          = 0;
 float pulse    = 0.0;
 float alpha    = 1.0;
 float y_offset = 0.0;
 Vector2 pos    = { 0, 0 };
 Vector2 len    = { 0, 0 };
 char strang[80];

 int sum_start = SCREEN_H * 0.2;
 int spacing   = SCREEN_H / SUMMARY_BAR_SPACING;

 Color col   = BLANK;
 Color col_n = BLANK;

 // Measure text so we can justify it properly in the center of the bars
 //
 len = MeasureTextEx(summary_font, "A", summary_font.baseSize * SUMMARY_ITEM_SIZE, SUMMARY_ITEM_SIZE);
 y_offset = ((SCREEN_H / SUMMARY_BAR_SIZE) / 2) - (len.y / 2);

 DrawTextureEx(tex_summary_bg, pos, 0.0, 2.5, WHITE);

 justify_text_xy(summary_headers[0], (SCREEN_W / 2) + 8, (SCREEN_H  * 0.025) + 8, summary_font, Fade(BLACK, alpha), 6.0, 6.0);
 justify_text(summary_headers[0], SCREEN_H  * 0.025, summary_font, Fade(WHITE, alpha), 6.0, 6.0);

 /// Draw "score" slot
 ///DrawRectangle(SCREEN_W * 0.10, sum_start - 20, SCREEN_W * 0.8, SCREEN_H / SUMMARY_BAR_SIZE, Fade(BLACK, SUMMARY_BAR_ALPHA));

 for(i=0; i<SUMMARY_ITEMS; i++) {
     DrawRectangle(SCREEN_W * 0.10, sum_start + (spacing * (i+1)), SCREEN_W * 0.8, SCREEN_H / SUMMARY_BAR_SIZE, Fade(BLACK, SUMMARY_BAR_ALPHA));
                                }

 ///col = ColorFromHSV(SUMMARY_SCORE_COLOR, 1.0, 1.0);
 ///sprintf(strang, "%s   %d", summary_headers[1], summary_data[15]);
 ///justify_text(strang, sum_start + 6, summary_font, col, SUMMARY_ITEM_SIZE, SUMMARY_ITEM_SIZE);        /* SCORE - chill cyan */

 col   = ColorFromHSV(SUMMARY_ITEM_COLOR, 1.0, 1.0);
 col_n = ColorFromHSV(SUMMARY_NUMBER_COLOR, 1.0, 1.0);

 for(i=0; i<SUMMARY_ITEMS; i++) {
     justify_text_l(summary_items[i], SCREEN_W * 0.15, sum_start + (spacing * (i+1)) + y_offset /*26*/, summary_font, col, SUMMARY_ITEM_SIZE, SUMMARY_ITEM_SIZE);
     sprintf(strang, "%d%s", summary_data[i], summary_units[i]);
     justify_text_r(strang, SCREEN_W * 0.85, sum_start + (spacing * (i+1)) + y_offset /*26*/, summary_font, col_n, SUMMARY_ITEM_SIZE, SUMMARY_ITEM_SIZE);
                                }


 // Dialog will be replaced by a menu for mouse input
 //
 #ifndef MOUSE_IS_PRIMARY
     pulse = sin(TO_RADIANS(anims[4])) * 0.50;
     justify_text_xy("[ PRESS 'Z' TO CONTINUE ]", (SCREEN_W / 2) + 3, SCREEN_H - 62, summary_font, Fade(BLACK, 0.50 + pulse), 3, 3);
     justify_text("[ PRESS 'Z' TO CONTINUE ]", SCREEN_H - 65, summary_font, Fade(WHITE, 0.50 + pulse), 3, 3);
 #endif

 return;
}




void draw_high_score()
{
 #ifndef PLATFORM_WEB
     #ifdef USE_HIGH_SCORE

 int i       = 0;
 float pulse = 0.0;
 Vector2 pos = { 0, 0 };

 Vector2 in_pos = { 350, 350 };

 unsigned char temp_text[2] = { 0, 0 };

 DrawTextureEx(tex_summary_bg, pos, 0.0, 2.5, WHITE);


 // Draw initials real freaking big
 //
 for(i=0; i<3; i++) {
     if(hi_score.initials[i] != 0) { temp_text[0] = hi_score.initials[i]; }
     else                          { temp_text[0] = 95;                   }

     // if position is selected, draw cursor instead
     //
     if(hi_score.selected == i) { temp_text[0] = 95; } // underscore!

     in_pos.x = 360 + (200 * i); // 232 for 1024x instead of 360 for 1280
     if(!hi_score.blink || i != hi_score.selected) { DrawTextEx(hi_score_font, (const char *)temp_text, in_pos, hi_score_font.baseSize * 10, 1, YELLOW); }
                    }

 // Track blinking
 //
 hi_score.blink_timer++;
 if(hi_score.blink_timer > 20) { hi_score.blink ^= 1; hi_score.blink_timer = 0; }


 pulse = sin(TO_RADIANS(anims[4])) * 0.25;
 justify_text_xy("ENTER INITIALS TO CONTINUE", (SCREEN_W / 2) + 3, SCREEN_H - 62, hi_score_font, Fade(BLACK, 0.75 + pulse), 3, 3);
 justify_text("ENTER INITIALS TO CONTINUE", SCREEN_H - 65, hi_score_font, Fade(WHITE, 0.75 + pulse), 3, 3);
     #endif // USE_HIGH_SCORE
 #endif // PLATFORM_WEB

 return;
}


