#include "Project.h"
#include "raymath.h" // Needed for vector2scale






// NOTE: Checks player input for activity
//
void check_input()
{
 /// float move_rate    =  5.0;
 int moving         = -1;
 int i              = 0;



 // Map inputs to virtual d_pad
 // These will be picked up in menus, etc
 //
 if(!flags.gamepad) {
     if(IsKeyDown(KEY_UP) || IsKeyDown(KEY_W))    { actors[puppet].d_pad[0] = 1; }
     else                                         { actors[puppet].d_pad[0] = 0; actors[puppet].d_repeat[0] = 0; }

     if(IsKeyDown(KEY_LEFT) || IsKeyDown(KEY_A))  { actors[puppet].d_pad[1] = 1; }
     else                                         { actors[puppet].d_pad[1] = 0; actors[puppet].d_repeat[1] = 0; }

     if(IsKeyDown(KEY_DOWN) || IsKeyDown(KEY_S))  { actors[puppet].d_pad[2] = 1; }
     else                                         { actors[puppet].d_pad[2] = 0; actors[puppet].d_repeat[2] = 0; }

     if(IsKeyDown(KEY_RIGHT) || IsKeyDown(KEY_D)) { actors[puppet].d_pad[3] = 1; }
     else                                         { actors[puppet].d_pad[3] = 0; actors[puppet].d_repeat[3] = 0; }

     if(IsKeyDown(KEY_Z)) { actors[puppet].buttons[0] = 1; }
     else                 { actors[puppet].buttons[0] = 0; actors[puppet].b_repeat[0] = 0; }

     if(IsKeyDown(KEY_X)) { actors[puppet].buttons[1] = 1; }
     else                 { actors[puppet].buttons[1] = 0; actors[puppet].b_repeat[1] = 0; }

     if(IsKeyDown(KEY_C)) { actors[puppet].buttons[2] = 1; }
     else                 { actors[puppet].buttons[2] = 0; actors[puppet].b_repeat[2] = 0; }

     if(IsKeyDown(KEY_V)) { actors[puppet].buttons[3] = 1; }
     else                 { actors[puppet].buttons[3] = 0; actors[puppet].b_repeat[3] = 0; }

                    }

 else {
     if(IsGamepadButtonDown(0, GAMEPAD_BUTTON_LEFT_FACE_UP))    { actors[puppet].d_pad[0] = 1; }
     else                                                       { actors[puppet].d_pad[0] = 0; actors[puppet].d_repeat[0] = 0; }

     if(IsGamepadButtonDown(0, GAMEPAD_BUTTON_LEFT_FACE_LEFT))  { actors[puppet].d_pad[1] = 1; }
     else                                                       { actors[puppet].d_pad[1] = 0; actors[puppet].d_repeat[1] = 0; }

     if(IsGamepadButtonDown(0, GAMEPAD_BUTTON_LEFT_FACE_DOWN))  { actors[puppet].d_pad[2] = 1; }
     else                                                       { actors[puppet].d_pad[2] = 0; actors[puppet].d_repeat[2] = 0; }

     if(IsGamepadButtonDown(0, GAMEPAD_BUTTON_LEFT_FACE_RIGHT)) { actors[puppet].d_pad[3] = 1; }
     else                                                       { actors[puppet].d_pad[3] = 0; actors[puppet].d_repeat[3] = 0; }


     if(IsGamepadButtonDown(0, GAMEPAD_BUTTON_RIGHT_FACE_UP))    { actors[puppet].buttons[0] = 1; }
     else                                                        { actors[puppet].buttons[0] = 0; actors[puppet].b_repeat[0] = 0; }

     if(IsGamepadButtonDown(0, GAMEPAD_BUTTON_RIGHT_FACE_LEFT))  { actors[puppet].buttons[1] = 1; }
     else                                                        { actors[puppet].buttons[1] = 0; actors[puppet].b_repeat[1] = 0; }

     if(IsGamepadButtonDown(0, GAMEPAD_BUTTON_RIGHT_FACE_DOWN))  { actors[puppet].buttons[2] = 1; }
     else                                                        { actors[puppet].buttons[2] = 0; actors[puppet].b_repeat[2] = 0; }

     if(IsGamepadButtonDown(0, GAMEPAD_BUTTON_RIGHT_FACE_RIGHT)) { actors[puppet].buttons[3] = 1; }
     else                                                        { actors[puppet].buttons[3] = 0; actors[puppet].b_repeat[3] = 0; }
      }


 // Only check these controls if the game is active
 //
 if(flags.game_mode != 2) { return; }


     if(actors[puppet].d_pad[0]) { // Up
         moving = 0;
         if(actors[puppet].pos.y > 50) { /*actors[puppet].pos.y -= move_rate;*/ }
                                 }

     if(actors[puppet].d_pad[2]) { // Down
         moving = 2;
         if(actors[puppet].pos.y < (SCREEN_H * MAP_SIZE) - 50) { /*actors[puppet].pos.y += move_rate;*/ }
                                 }


     if(actors[puppet].d_pad[1]) { // Left
         moving = 1;
         if(actors[puppet].pos.x > 0) { /*actors[puppet].pos.x -= (move_rate * 1.2);*/ }
                                 }

     if(actors[puppet].d_pad[3]) { // Right
         moving = 3;
         if(actors[puppet].pos.x < (SCREEN_W * MAP_SIZE)) { /*actors[puppet].pos.x += (move_rate * 1.2);*/ }
                                 }



 // First pass to detect mouse-overs, if mouse controlled
 // This should really go elsewhere
 //
 #ifdef MOUSE_IS_PRIMARY
 flags.button_pos = -1;

 for(i=0; i<MAX_BUTTONS; i++) {
     if(buttons[i].enabled) {
         if(flags.mouse.x > buttons[i].pos.x &&
            flags.mouse.x < (buttons[i].pos.x + buttons[i].w) &&
            flags.mouse.y > buttons[i].pos.y &&
            flags.mouse.y < (buttons[i].pos.y + buttons[i].h)) { flags.button_pos = i; }
                            }
                              }
 #endif


 return;
}






void check_delta_updates()
{
 float clock_ticks  = ((BASE_TICKS * flags.game_speed) / 60.0);  // In future, make FPS variable by user. Change here
 float ms_per_frame = (1.000 / 60.0);       // Ditto
 float updates      = 0.0;
 int   i            = 0;

 // Get delta time
 //
 flags.delta = GetFrameTime();
 flags.game_time += (flags.delta * 60.0);

 // Set up delta factor (this should be damn close to 1.0)
 //
 if(flags.delta_factor > 0.01) { flags.delta_factor = (flags.delta / ms_per_frame); }
 else                          { flags.delta_factor = 1.000;                        }



 // Also add in leftovers from last frame that didn't make the cut.
 //
 updates = (clock_ticks * flags.delta_factor);
 updates += flags.timing_leftover;


 // Round down to store our total updates for this frame
 // Partial values (i.e. x < 1.0) will get stored away for next cycle
 //
 flags.last_updates    = (int)updates;
 flags.timing_leftover = fmod(updates, 1.00);


 // Do as many updates as we've clocked in
 //
 for(i=0; i<flags.last_updates; i++) {
     check_input();

     #ifdef USE_ANIMATIONS
         check_animations();
     #endif

     #ifdef USE_TEXTBOX
         check_textbox();
     #endif

     #ifdef USE_RINGS
         check_rings();
     #endif

     #ifdef USE_EJECTA
         check_chains();
     #endif

     #ifdef USE_MENUS
         check_menus();
     #endif

     check_game_specific_anims();
     check_misc_logic();

     check_shaders();

     if(!flags.game_over &&
        !flags.stage_complete &&
         flags.game_mode > 1) {
             check_game_over();
             check_score();
                              }

     check_actors();
     check_actors_while_paused();
                                     }


 // One per frame is sufficient for some things
 //
 #ifdef USE_TIPS
     if(flags.tutorial) { check_tips(); }
 #endif // USE_TIPS

 return;
}





// NOTE: Keeps track of game time, and parses the ticks left
//       into human readable format
//
void check_time()
{
 div_t d;
 div_t e;

 if(flags.game_mode != 2) { return; }


 d = div(flags.game_time, 3600);

 flags.clock_min = d.quot;

 e = div(flags.game_time - (d.quot * 3600), 60);
 flags.clock_sec = e.quot;
 flags.clock_sub = e.rem;

 return;
}



#ifdef USE_MENUS
void check_menus()
{
 int i = 0;

 for(i=0; i<MAX_MENUS; i++) {
     if(menus[i].enabled) {
         if(menus[i].open && menus[i].close) { log(LOG_ALWAYS, "MENU STATE POTENTIALLY CORRUPT - %d", i); menus[i].close = 1; } // Resolve possible state conflict

         if(menus[i].open) {
             menus[i].anim_linear += 0.04;
             if(menus[i].anim_linear > 1.0) { menus[i].anim_linear = 1.0; menus[i].open = 0; }

             menus[i].anim = tan_scale(menus[i].anim_linear, 0.0, 1.0, 0.0, 1.0);
                           }

         if(menus[i].close) {
             menus[i].anim_linear -= 0.04;
             if(menus[i].anim_linear < 0.0) { menus[i].anim_linear = 0.0; menus[i].close = 0; menus[i].enabled = 0; }

             menus[i].anim = log_scale(menus[i].anim_linear, 0.0, 1.0, 0.0, 1.0);
                            }
                          }
                            }

 return;
}
#endif



// Adjusts score over time
//
void check_score()
{
 int i      = 0;
 int factor = 1;
 int total  = 0;


 for(i=0; i<MAX_SCORE; i++) {
     // Score shakes when bad things happen
     //
     if(flags.score_shake[i] > 0) { flags.score_shake[i]--; }


     // Roll differential into score over time. The larger the difference,
     // the faster we will update the score. Eventually roll this into a log formula.
     //
     if(flags.score_diff[i] != 0) {

         total = abs(flags.score_diff[i]);
         if(total > 20)   { factor = 2;  }
         if(total > 50)   { factor = 4;  }
         if(total > 100)  { factor = 8;  }
         if(total > 250)  { factor = 16; }
         if(total > 500)  { factor = 32; }
         if(total > 999)  { factor = 64; }
         if(total > 1999) { factor = 128; }
         if(total > 3999) { factor = 256; }
         if(total > 6999) { factor = 512; }

         if(flags.score_diff[i] > 0) { flags.score[i] += factor; flags.score_diff[i] -= factor; }
         if(flags.score_diff[i] < 0) { flags.score[i] -= factor; flags.score_diff[i] += factor; }
                                  }

     // Bounds check
     //
     if(flags.score[i] < 0)        { flags.score[i] = 0;        }
     if(flags.score[i] > 99999999) { flags.score[i] = 99999999; }
                            }

 return;
}





void check_shaders()
{

 // Used by *quite* a lot of shaders
 //
 seconds += GetFrameTime();


 // Update shaders
 //
 #ifdef USE_WAVE_SHADER
     SetShaderValue(wave, secondsLoc, &seconds, SHADER_UNIFORM_FLOAT);
 #endif


 m_var = flags.mosaic * 0.05;
 SetShaderValue(mosaic, mos_mLoc, &m_var, SHADER_UNIFORM_FLOAT);

 #ifdef USE_BLOOM_SHADER
     b_var = flags.bloom;
     SetShaderValue(bloom, blo_sLoc, &b_var, SHADER_UNIFORM_FLOAT);
 #endif


 // Update Cut-out scroll shader
 //
 #ifdef USE_SCROLL_SHADER
     scroll_vars[0] += 0.0003;
     scroll_vars[1] += 0.0005;

     scroll_vars[2] -= 0.0004;
     scroll_vars[3] += 0.00025;
 #endif

 return;
}





// NOTE: General-purpose animations (should be relatively the same per-project)
//
void check_animations()
{
 int i = 0;
 int SET = 0;


 if(flags.follow_ship != -1) { laggy_cam(flags.follow_ship); }

 zoom_tracking();


 for(i=0; i<MAX_ACTORS; i++) {
     if(actors[i].enabled && actors[i].anim_set) {
         SET = actors[i].anim_set;

         actors[i].anim_timing++;

         // Check for frame advance
         //
         if(actors[i].anim_timing >= anim[SET].timing[actors[i].anim_step]) {
             actors[i].anim_step++;
             actors[i].anim_timing = 0;

             // Check for end, or looping
             //
             if(actors[i].anim_step >= anim[SET].total_frames) {
                 if(actors[i].anim_loop) {
                     actors[i].anim_step = 0;
                     actors[i].anim_timing = 0;
                     actors[i].anim_loop--;
                                         }

                 else { actors[i].anim_set = 0; }
                                                               }
                                                                            }

         // If anim is still set, update frame
         // ** SHOULD PLACE IN ROUTINE SO WE CAN SANITY CHECK ANIM_STEP VALUE **
         //
         if(actors[i].anim_set) {
             SET = actors[i].anim_set;
             actors[i].cel_x = anim[SET].frame_x[actors[i].anim_step];
             actors[i].cel_y = anim[SET].frame_y[actors[i].anim_step];
                                }
                                                 }
                             }

 // Signal tracking
 //
 if(flags.show_signal != -1) {
     flags.signal_time++;
     if(flags.signal_time > flags.signal_max_time) {
         flags.signal_time = 0;
         flags.signal_max_time = 0;
         flags.show_signal = -1;
                                                   }
                             }

 #ifdef USE_BULLETIN
     Vector2 len = { 0 };
     if(bulletin.enabled && bulletin.time_left > 0) { bulletin.time_left--; }

     bulletin.x += bulletin.speed;
     len = MeasureTextEx(bulletin.font, bulletins[bulletin.message], bulletin.font.baseSize * bulletin.f_scale, bulletin.f_spacing);

     if(bulletin.x > len.x) { bulletin.x -= len.x; }

 #endif


 // Full-screen tint tracking
 //
 if(flags.tint_velocity != 0.0) {
     flags.tint_str += flags.tint_velocity;
     if(flags.tint_str >= 1.00) { flags.tint_str = 1.00; flags.tint_velocity = 0.0; }
     if(flags.tint_str <= 0.00) { flags.tint_str = 0.00; flags.tint_velocity = 0.0; }
                                }


 // Mosaic tracking
 //
 if(flags.mosaic_chirp != 0.0) {
     flags.mosaic = sin(TO_RADIANS(90.0 + (180.0 * flags.mosaic_chirp))) * 0.25;

     flags.mosaic_chirp += 0.03;
     if(flags.mosaic_chirp >= 1.0) { flags.mosaic_chirp = 0.0; }
                               }
 else {
     if(flags.mosaic_velocity != 0.0) {
         flags.mosaic += flags.mosaic_velocity;
         if(flags.mosaic >= 1.00) { flags.mosaic = 1.00; flags.mosaic_velocity = 0.0; }
         if(flags.mosaic <= 0.00) { flags.mosaic = 0.00; flags.mosaic_velocity = 0.0; }
                                      }
      }


 // Game speed tracking
 //
 if(flags.game_velocity != 0.0) {
     flags.game_speed += flags.game_velocity;
     if(flags.game_speed >= 1.00) { flags.game_speed = 1.00; flags.game_velocity = 0.0; }
     if(flags.game_speed <= 0.00) { flags.game_speed = 0.00; flags.game_velocity = 0.0; }
                                  }


 // Floating object animation
 //
 anims[2] += 1.0;
 if(anims[2] > 360.00) { anims[2] -= 360.00; }


 // Medium flashing indicator timer
 //
 anims[3] += 0.01;
 if(anims[3] > 1.00) { anims[3] -= 1.00; }


 // UI selection pulsing animation
 //
 anims[4] += 4.0;
 if(anims[4] > 360.00) { anims[4] -= 360.00; }


 // Quake damage pulsing (fed into sin())
 //
 anims[5] += 8.0;
 if(anims[5] > 360.00) { anims[5] -= 360.00; }


 // Holding position shuffle (slow, lazy sine)
 //
 anims[6] += 0.01;
 if(anims[6] > 360.00) { anims[6] -= 360.00; }


 // Flashing Title indicator (50% to 100% opacity)
 //
 anims[7] += 0.04;
 if(anims[7] > 360.00) { anims[7] -= 360.00; }


 // Stripe banner sliding animation
 //
 anims[8] += 0.1;
 if(anims[8] > 32.00) { anims[8] -= 32.00; }


 // Signal fade
 //
 anims[9] -= 0.01;
 if(anims[9] < 0.00) { anims[9] = 0.00; }


 // Star field rotation animation
 //
 anims[10] += 0.5;
 if(anims[10] >= 360.00) { anims[10] -= 360.00; }


 // TEST ANIMATION
 //
 anims[11] += 6.0;
 if(anims[11] >= 360.00) { anims[11] -= 360.00; }


 // Flickering aura rotation animation
 //
 anims[13] += 2.0;
 if(anims[13] >= 360.00) { anims[13] -= 360.00; }


 // Title emoji animation
 //
 anims[14] += 1.5;
 if(anims[14] >= 360.00) { anims[14] -= 360.00; }


 // Title emoji animation
 //
 anims[15] += 0.5;
 if(anims[15] >= 360.00) { anims[15] -= 360.00; }


 return;
}






// Kills off dead actors, spawns new ones over time
//
void check_actors()
{
 int i           = 0;
 int j           = 0;
 int k           = 0;
 float dist      = 0.0;

 if(flags.paused) { return; }

 for(i=0; i<MAX_ACTORS; i++) {
     if(actors[i].enabled) {
         // Actor is quaking
         //
         if(actors[i].quake > 0.000) {
             actors[i].angle = sin(anims[5]) * actors[i].quake;
             actors[i].quake -= 0.10;
             if(actors[i].quake <= 0.000) {
                 actors[i].angle = 0.0;
                 actors[i].quake = 0.0;
                                          }
                                     }

         // Actor is jittering (Y axis)
         //
         if(actors[i].jitter_y) {
             actors[i].jitter_y--;
             if(actors[i].jitter_y < 0) { actors[i].jitter_y = 0; }
                                }


         // Actor is sprite rolling, angle rolling, or flickering
         //
         if(actors[i].roll > 0.001 || actors[i].roll < -0.001) { actors[i].angle += actors[i].roll; }
         if(actors[i].v_roll > 0.001 || actors[i].v_roll < -0.001) { actors[i].v_angle += actors[i].v_roll; }


         switch(actors[i].state) {
             case 0: // Inactive
                     break;

             case 1: // Fades out quickly and expires (player trail)
                     actors[i].blend -= 0.035;
                     if(actors[i].blend <= 0.00) { kill_actor(i); }
                     break;

             case 2: // Rises. Waits for stamina to run out. Then dies
                     actors[i].stamina--;
                     if(actors[i].stamina <= 0) {
                         actors[i].flicker = 0;
                         actors[i].pos.z += 1.0;
                         actors[i].pos.x += actors[i].path.x;
                         actors[i].blend -= 0.005;
                         if(actors[i].blend <= 0.00) { kill_actor(i); }
                                                }
                     break;

             case 3: /// Angle + Speed movement (ON Z AXIS ONLY). + FADE OVER TIME
                     actors[i].pos.x += sin(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;
                     actors[i].pos.y -= cos(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;

                     actors[i].stamina--;
                     if(actors[i].stamina <= 0) { kill_actor(i); }

                     actors[i].blend -= 0.005;
                     if(actors[i].blend <= 0.00 ) { kill_actor(i); }
                     break;

             case 4: // Slides back and fades out
                     if(!actors[i].team) { actors[i].pos.x += 1.5; }
                     else                { actors[i].pos.x -= 1.5; }

                     actors[i].blend -= 0.015;
                     if(actors[i].blend <= 0.00) {
                         for(j=0; j<MAX_CREW; j++) {
                             if(flags.friends[j] == i) { flags.friends[j] = -1; }
                             if(flags.enemies[j] == i) { flags.enemies[j] = -1; }
                                                   }
                         kill_actor(i);
                                                 }
                     break;

             case 5: // Shot: Angle + speed movement + targeted collision
                     actors[i].pos.x += sin(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;
                     actors[i].pos.y -= cos(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;

                     actors[i].stamina--;
                     if(actors[i].stamina <= 0) {
                         actors[i].inert = 1;
                         actors[i].blend -= 0.06;
                         if(actors[i].blend <= 0.0) { kill_actor(i); break; }
                                                }

                     if(actors[i].inert > 0) { break; }


                     // Check for collision
                     //
                     k = actors[i].locked_to;
                     if(k != -1 && !actors[i].inert) {
                         dist = dist_2d(actors[i].pos.x, actors[i].pos.y - actors[i].pos.z - 8,
                                        actors[k].pos.x, actors[k].pos.y - actors[k].pos.z - 32);
                         if(dist < 40) {
                             apply_damage(i, k);
                             kill_actor(i);
                                       }
                                                     }
                     break;

             case 6: // Ship: Angle + speed movement (slowly spins and dies out)
                     actors[i].pos.x += sin(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;
                     actors[i].pos.y -= cos(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;

                     j = spawn_blot(actors[i].pos.x, actors[i].pos.y, 0.0, DARK_GRAY, 1.0, 1.0);
                     if(j != -1) { actors[j].blend = actors[i].blend; }

                     j = spawn_blot(actors[i].pos.x, actors[i].pos.y-48, 0.0, ORANGE, 0.25, 0.25);
                     if(j != -1) { actors[j].blend = actors[i].blend; }

                     actors[i].blend -= 0.0025;
                     if(actors[i].blend <= 0.00) { kill_actor(i); }
                     break;

             case 7: // Dead Body: Angle + speed movement (slowly spins and dies out)
                     actors[i].pos.x += sin(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;
                     actors[i].pos.y -= cos(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;

                     actors[i].blend -= 0.0025;
                     if(actors[i].blend <= 0.00) { kill_actor(i); }
                     break;

             case 8: // Celestial Fire: (slowly dies out)
                     actors[i].blend -= 0.0010;
                     if(actors[i].blend <= 0.00) { kill_actor(i); }
                     break;

            case 42: // Reserved for Douglas Adams
                     break;

            case 98: // Waits for stamina to run out. Then fades out and dies
                     actors[i].stamina--;
                     if(actors[i].stamina <= 0) {
                         actors[i].blend -= 0.01;
                         if(actors[i].blend <= 0.00) { kill_actor(i); }
                                                }
                     break;

            case 99: // Waits for stamina to run out. Then dies
                     actors[i].stamina--;
                     if(actors[i].stamina <= 0) { kill_actor(i); }
                     break;

                                 }
                           }
                             }

 // Should move following to a secondary pass, so movement and followers are synchronized
 // no matter where they fall in the actor list
 //
 for(i=0; i<MAX_ACTORS; i++) {
     if(actors[i].enabled) {

         // Actor is following another
         //
         if(actors[i].following != -1) {
             k = actors[i].following;
             actors[i].pos.x = actors[k].pos.x + actors[i].follow_x;
             actors[i].pos.y = actors[k].pos.y + actors[i].follow_y; // + 99;
             ///actors[i].pos.z = actors[k].pos.z + 64;
                                       }
                           }
                             }

 return;
}





// NOTE: Checks for "game over" and "Stage complete" conditions
//       These will vary between projects
//
void check_game_over()
{
 int total = 0;

 if(flags.game_mode != 2) { return; }

 // Save this code to show what you want to do on a stage complete/game over event
 /*
 if(flags.sacrifice_meter == 10 && !flags.stage_complete) {
     tint_velocity = 0.01;
     tint_col      = BLACK;
     tint_str      = 0.00;
     display_signal(0);
     flags.stage_complete = 1;
                                                          }
 */

 /// Game over for this project is:
 /// 1. All crew are dead

 total = count_crew(0);
 if(!total && !flags.game_ending) { kill_player(); }

 if(flags.mosaic > 0.80 && flags.game_ending && !flags.game_over) { flags.game_over = 1; }

 if(IsKeyDown(KEY_ESCAPE)) {
     hotkey_toggles[0] = 1;
     flags.game_over   = 1;
                           }
 else { hotkey_toggles[0] = 0; }

 return;
}






// NOTE: Project-specific random logic (as in not tied to an actor)
//       should be tossed in here
//
void check_misc_logic()
{
 if(flags.game_mode < 2) { return; }

 int i = 0;

 for(i=0; i<MAX_SHIPS; i++) {
     if(ships[i].enabled) { count_crew(i); }
                            }

 return;
}





// NOTE: Same as above, but only includes behaviors that must be
//       available during a system/event pause
//       This is janky, but I'm not building a huge framework (again) for all this
//
void check_actors_while_paused()
{

 return;
}





// Populates end-game summary with information
// Can be called at the end of a game session, or per-frame
//
void check_summary()
{
/*
 int total_rounds;                // Count of rounds played in the game
 int total_spent;                 // Total money spend on items (bribes not included)
 int total_deliveries;            // Total number of employees dropped off
 int total_wins;                  // Total battles won
 int total_losses;                // Total battles lost
 int total_deaths;                // Total crewmates lost in glorious service to their Master Pimps
*/
 summary_data[0]  = flags.total_rounds;
 summary_data[1]  = flags.total_spent;
 summary_data[2]  = flags.total_deliveries;
 summary_data[3]  = flags.total_wins;
 summary_data[4]  = flags.total_losses;
 summary_data[5]  = flags.total_deaths;
 summary_data[6]  = 0;
 summary_data[7]  = 0;
 summary_data[8]  = 0;
 summary_data[9]  = 0;
 summary_data[10] = 0;
 summary_data[11] = 0;
 summary_data[12] = 0;
 summary_data[13] = 0;
 summary_data[14] = 0;

 summary_data[15] = flags.retirement; // Score is always last item (jank, I know)

 return;
}





// NOTE: This can be cleared out per-project
//
void check_game_specific_anims()
{
 if(flags.paused) { return; }
 if(flags.game_mode != 2) { return; }

 int fire_check = -1;
 int i = 0;
 int j = 0;
 int dist = 0;
 float frequency[4] = { 1.00, 0.80, 0.50, 0.30 };
 Vector2 off_center = { 0 };
 Vector2 p_shift    = { 0 };

 // Update HUD scores
 //
 if(flags.score[0] != flags.retirement) {
     flags.score_diff[0] = flags.retirement - flags.score[0];
                                        }

 if(flags.score[1] != flags.coffer) {
     flags.score_diff[1] = flags.coffer - flags.score[1];
                                    }


 flags.sky_on_fire = 0;

 for(i=0; i<MAX_NODES; i++) {
     if(nodes[i].enabled) {
         if(nodes[i].planet_cel > 0) { nodes[i].planet_anim += 0.1; }

         if(nodes[i].fire_count) {
             fire_check = i;
             flags.sky_on_fire = 1;
             nodes[i].fire_radius += 14.0;
             if(nodes[i].fire_radius > 5000) {
                 nodes[i].fire_radius = 10.0;
                                             }
                                 }
                          }
                            }

 for(i=0; i<MAX_SHIPS; i++) {
     if(ships[i].enabled) {
         if(ships[i].orbiting > -1) { ships[i].orbit_anim += 0.4; }
                          }
                            }

 // misc anims
 //
 if(flags.round_anim < 1.00) {
     if(!flags.slow_advance) { flags.round_anim += 0.025; }
     else                    { flags.round_anim += 0.0035; }
                             }

 if(flags.combat_anim > 0.0 && flags.combat_result == -1) {
     flags.combat_anim += 0.025;
     if(flags.combat_anim > 1.00) { flags.combat_anim = 1.00; }
                                                          }

 if(flags.wanted_anim > 0.001) {
     if(flags.wanted_level) { flags.wanted_anim += 0.01; }
     else                   { flags.wanted_anim -= 0.01; }
                               }

 if(flags.wanted_anim > 1.00) { flags.wanted_anim = 1.00; }
 if(flags.wanted_anim < 0.00) { flags.wanted_anim = 0.00; }


 // Update stars
 //
 off_center.x = ((SCREEN_W * MAP_SIZE) / 2.0) - camera.target.x;
 off_center.y = ((SCREEN_H * MAP_SIZE) / 2.0) - camera.target.y;

 for(i=0; i<4; i++) {
     for(j=0; j<(int)(STAR_DENSITY * frequency[i]); j++) {
         if(fire_check != -1) {
             p_shift = get_star_pos(i, j, off_center);
             dist = dist_2d((int)nodes[fire_check].pos.x, (int)nodes[fire_check].pos.y, (int)p_shift.x, (int)p_shift.y);
             if(abs(dist - nodes[fire_check].fire_radius) < 15) { star_vars[i][j].y = 1.0; }
                              }

         if(star_vars[i][j].y > 0.0) {
             star_vars[i][j].y -= 0.0075;
             if(star_vars[i][j].y < 0.0) { star_vars[i][j].y = 0.0; }
                                     }
                                                         }
                    }

 if(flags.in_combat && flags.combat_result == -1) { process_combat(); }
 if(flags.in_combat && flags.combat_result != -1) { resolve_combat(); }


 return;
}





// NOTE: This can be cleared out per-project
//       This is also executed inside the main loop (AND WILL HOLD IT UP)
//       so be careful not to do anything that would call this again,
//       otherwise you bork the universe
//
void check_game_specific_logic()
{
 if(flags.paused) { return; }
 if(flags.game_mode != 2) { return; }

 int chosen        = 0;
 int button_event  = -1;
 Vector2 m_delta   = { 0 };
 float m_wheel     = 0.0;


 // Check mouse position if not in menus
 //
 if(flags.in_menu == -1) {
     if(IsMouseButtonDown(MOUSE_BUTTON_RIGHT)) {
         flags.follow_ship = -1;
         m_delta = GetMouseDelta();
         m_delta = Vector2Scale(m_delta, -1.0f / camera.zoom);

         camera.target = Vector2Add(camera.target, m_delta);
                                               }
     else { flags.m_hold[1] = 0; }
                         }


 // Check mouse zoom if not in menus
 //
 if(flags.in_menu == -1) {
     m_wheel = GetMouseWheelMove();
     if(m_wheel != 0) {
         flags.zoom_target += (m_wheel * 0.125f);
         if(flags.zoom_target < 0.50) { flags.zoom_target = 0.50; }
         if(flags.zoom_target > 1.50) { flags.zoom_target = 1.50; }
                      }

     if(IsMouseButtonDown(MOUSE_BUTTON_MIDDLE)) { flags.zoom_target = 1.0; }

                         }


 // Execute a end of turn if double-clicking on a selected node
 //
 if(flags.in_menu == -1 &&
    !flags.event_pending &&
    !flags.in_combat) {

     button_event = check_button_events();

     if(button_event == 0) { flags.turn_pending  = 1;  }
     if(button_event == 1) { flags.event_pending = 9;  }

     if(IsMouseButtonDown(MOUSE_BUTTON_LEFT)) {
         if(!flags.m_hold[0]) {
             flags.m_hold[0] = 1;
             chosen = find_node(GetScreenToWorld2D(GetMousePosition(), camera));
             log(LOG_1, "NODE %d FOUND!\n", chosen);

             // If player selects the same node they are orbiting,
             // look for an applicable event
             //
             if(chosen != ships[0].orbiting) { flags.node_selected = chosen; }
             else {
                 flags.node_selected = -1;
                 log(LOG_1, "Looking for events at node %d", chosen);
                 flags.event_pending = find_event(chosen);
                 log(LOG_1, "Event found: %d", flags.event_pending);
                  }

             if(flags.node_selected > -1) {
                 if(flags.node_selected == flags.last_node) { flags.turn_pending = 1; }
                 else {
                     flags.path_locked = find_path(0, ships[0].orbiting, flags.node_selected);
                     flags.last_node = flags.node_selected;

                     if(flags.path_locked) { ships[0].going_to = node_path[1]; }
                     else                  { ships[0].going_to = -1;           }
                      }
                                          }
             else {
                 clear_path_selection();
                  }
                              }
                                              }
     else { flags.m_hold[0] = 0; }
                      }


 if(flags.turn_pending) {
     flags.turn_pending = 0;
     flags.follow_ship = 0;

     // If we pass the turn, we need to not call for a long haul
     // Tutorial is restricted to a single jump per round
     //
     if(button_event == 0) { next_round(1); }
     else {
         if(!flags.tutorial) { long_haul();   }
         else                { next_round(0); }
          }

     clear_path_selection();
                        }

 check_events();

 if(flags.retreat_pending != -1) {
     force_retreat(flags.retreat_pending);
     flags.retreat_pending = -1;
                                 }


 return;
}




// NOTE: Checks for events at the player's current location, and
//       returns > 0 if an event was found
//
int check_events()
{
 int i           = 0;
 int event       = 0;
 int result      = 0;
 int local_event = -1;
 int enemy       = -1;

 if(flags.game_ending) { return(0); }
 if(flags.in_combat)   { return(0); }


 // check for win condition before any other, because I'm such a nice guy
 //
 if(flags.retirement >= 75000) {
     winning_menu();
     kill_player();
     return(0);
                               }


 if(flags.combat_pending == -1) {
     for(i=0; i<MAX_SHIPS; i++) {
         if(ships[i].enabled) {
             ships[i].c_anim++;
             if(ships[i].c_anim > 30) {
                 ships[i].c_anim = 0;
                 if(ships[i].coffins[0] != -1) { unload_coffin(i); }
                                      }
                              }
                                }
                                }

 // Not really sure where this should go
 // But it determines if combat can occur (among other things)
 //
 flags.cargo_total  = ships[0].cargo[0] + ships[0].cargo[1] + ships[0].cargo[2] + ships[0].cargo[3];


 if(ships[0].orbiting != -1) { local_event = find_event(ships[0].orbiting); }
 if(local_event == 20) { flags.event_pending = 20; }
 if(local_event == 21) { flags.event_pending = 21; }
 if(local_event == 22) { flags.event_pending = 22; }
 if(local_event == 23) { flags.event_pending = 23; }
 if(local_event == 24) { flags.event_pending = 24; }

 // Scan for enemies in same space
 // You will be ignored if retreating, the ship is destroyed,
 // the ship has been bribed, you have *no* cargo on board,
 // or a celestial fire event is active
 //
 if(flags.combat_pending == -1 &&
    flags.retreat_pending == -1 &&
    flags.in_menu == -1 &&
    !flags.sky_on_fire) {
     for(i=1; i<MAX_SHIPS; i++) {  /// Player ship is skipped in this scan
         if(ships[i].enabled) {
             if(ships[i].team == 1 &&
                !ships[i].destruct &&
                flags.retreat_pending != i) {
                 if(ships[i].orbiting == ships[0].orbiting) {
                     if((!ships[i].bribed && flags.cargo_total > 0) || flags.wanted_level) {
                         enemy = i; flags.event_pending = 10; log(LOG_1, "ATTACKED BY %d", i); break;
                                                                                           }
                                                            }
                                            }
                              }

         if(ships[i].destruct) { clone_ship(i, 0); }
                                }
                        }



 // LIST OF EVENTS:
 //  1 = Pimpstation
 //  2 = Advanced Pimpstation
 //  3 = Starship Pimping
 //  4 = Cargo planet
 //  9 = Summary event
 // 10 = COMBAT
 // 20 = Voidstar

 if(flags.event_pending == 1)  { event = 1; pimpstation_menu(); flags.event_pending = 0; }
 if(flags.event_pending == 2)  { event = 2; advanced_pimping_menu(); flags.event_pending = 0; }
 if(flags.event_pending == 3)  { event = 3; starship_pimping_menu(); flags.event_pending = 0; }
 if(flags.event_pending == 4)  { event = 4; cargo_menu(); flags.event_pending = 0; }
 if(flags.event_pending == 9)  { event = 9; summary_menu(); flags.event_pending = 0; }


 // Voidstar
 //
 if(flags.event_pending == 20) {
     event = 20;
     log(LOG_1, "toasty!");
     voidstar_menu();
     flags.event_pending = 0;
     force_retreat(0);
                               }

 // Warp Coil
 //
 if(flags.event_pending == 21) {
     event = 21;
     log(LOG_1, "warp coil entered");
     warp_coil_menu();
     flags.event_pending = 0;
                               }

 // Salvage
 //
 if(flags.event_pending == 22) {
     event = 22;
     log(LOG_1, "Salvage found");
     salvage_menu(ships[0].orbiting);
     flags.event_pending = 0;
                               }

 // Rescue
 //
 if(flags.event_pending == 23) {
     event = 23;
     log(LOG_1, "Rescue found");
     rescue_menu(ships[0].orbiting);
     flags.event_pending = 0;
                               }

 // Celestial Fire
 //
 if(flags.event_pending == 24) {
     event = 24;
     log(LOG_1, "Celestial Fire");
     celestial_fire_menu(ships[0].orbiting);
     flags.event_pending = 0;
                               }


 // Combat event
 //
 if(flags.event_pending == 10) {
     event = 10;
     flags.event_pending = 0;
     result = bacon_menu(enemy);

     switch(result) {
         case 0: // FIGHT IT OUT
                 prepare_for_combat(enemy);
                 break;

         case 1: // Have you considered bribery?
                 ships[enemy].bribed = 5;
                 force_retreat(enemy);
                 break;

         case 2: // Escape!
                 force_retreat(0);
                 break;
                    }
                               }


 // Fuzz
 //
 if(flags.fuzz_pending != -1) {
     create_fuzz_ship(quick_rand(flags.fuzz_level + 1), -1);
     flags.fuzz_pending = -1;
                              }


 return(event);
}



