#include "Project.h"



/// STANDARD FEATURES
///
int   puppet          = -1;
float anims[16]       = { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 };

Camera2D camera       = { 0 };
Vector2 mouse         = { 0, 0 };
Vector2 mouse_cam     = { 0, 0 };


const char *main_options[] = {
 /* 00 */ "START GAME",
 /* 01 */ "TUTORIAL",
 /* 02 */ "EXIT",
 /* 03 */ "...",
 /* 04 */ "...",
 /* 05 */ "...",
 /* 06 */ "...",
 /* 07 */ "...",
 /* 08 */ "...",
 /* 09 */ "..."
};



const char *summary_headers[] = {
 /* 00 */ "G A M E   O V E R",
 /* 01 */ "FINAL SCORE",
 /* 02 */ "...",
 /* 03 */ "...",
 /* 04 */ "...",
};


const char *summary_items[] = {
 /* 00 */ "GAME TURNS",
 /* 01 */ "MONEY SPENT",
 /* 02 */ "DELIVERIES",
 /* 03 */ "BATTLES WON",
 /* 04 */ "BATTLES LOST",
 /* 05 */ "CREWMATES KILLED",
 /* 06 */ "...",
 /* 07 */ "...",
 /* 08 */ "...",
 /* 09 */ "...",
 /* 10 */ "...",
 /* 11 */ "...",
 /* 12 */ "...",
 /* 13 */ "...",
 /* 14 */ "...",
 /* 15 */ "..."
};


const char *summary_units[] = {
 /* 00 */ "",
 /* 01 */ "",
 /* 02 */ "",
 /* 03 */ "",
 /* 04 */ "",
 /* 05 */ "",
 /* 06 */ "",
 /* 07 */ "",
 /* 08 */ "",
 /* 09 */ "",
 /* 10 */ "",
 /* 11 */ "",
 /* 12 */ "",
 /* 13 */ "",
 /* 14 */ "",
 /* 15 */ ""
};


const char *menu_keyboard_tips[] = {
 /* 00 */ "ARROWS/WASD - MOVE         Z - SELECT",
 /* 01 */ "J/K - JOYSTICK/KEYBOARD"
};

const char *menu_gamepad_tips[] = {
 /* 00 */ "ANALOG STICK 1 - MOVE      Z - SELECT",
 /* 01 */ "J/K - JOYSTICK/KEYBOARD"
};

const char *game_keyboard_tips[] = {
 /* 00 */ "ARROWS/WASD - MOVE",
 /* 01 */ "Z - PIMP      X - SLAP"
};

const char *game_gamepad_tips[] = {
 /* 00 */ "ANALOG STICK 1 - MOVE",
 /* 01 */ "TOP BUTTON - FIRE       LEFT BUTTON - FLIP"
};


/// SHADERS
///
// Shader crap here (plz move this into something sane FFS)
//
#ifdef USE_SCROLL_SHADER
    Shader scroll;
    float scroll_vars[4] = { 0.0, 0.0, 0.0, 0.0 }; // Two sets of x/y offsets
    int off_xLoc   = 0;
    int off_yLoc   = 0;
#endif

Shader mosaic;
float m_var = 0.0;
int mos_mLoc;
int mos_aLoc;

#ifdef USE_BLOOM_SHADER
    Shader bloom;
    float b_var = 0.0;
    int blo_sLoc;
#endif

#ifdef USE_WAVE_SHADER
Shader wave;
float s_vars[6] = {  4.0,  0.0,  4.0, 0.0,  2.0,  0.0 };  // Brush sine wave
float l_vars[6] = {  3.0,  2.0,  6.0, 8.0,  3.0,  2.5 };  // Title emoji
float k_vars[6] = {  6.0, 00.0, 32.0, 0.0,  1.0,  0.0 };  // Kelp sine wave
float h_vars[6] = { 10.0, 00.0, 64.0, 0.0,  2.0,  0.0 };  // Hook sine wave
float f_vars[6] = { 10.0, 10.0,  4.0, 4.0, 18.0, 18.0 };  // Fire sine wave
int secondsLoc = 0;
int freqXLoc   = 0;
int freqYLoc   = 0;
int ampXLoc    = 0;
int ampYLoc    = 0;
int speedXLoc  = 0;
int speedYLoc  = 0;

int loc_time     = 0;
int loc_strength = 0;
float seconds    = 0.0f;
float strength   = 0.0005f;
#endif

Shader crt;
Shader edge_fade;



/// PROJECT-SPECIFIC
///
int crew_cost[MAX_CREW]   = { 1000,  1100, 1400, 2500 };
int upgrade_cost[4]       = { 10000, 4000, 5000, 8000 };
int cargo_cost[MAX_CARGO] = {  100,  100,  100,  100  };

const char *fuzz_titles[] = {
 /* 00 */ "LOW FUZZ",
 /* 01 */ "MEDIUM FUZZ",
 /* 02 */ "HIGH FUZZ",
 /* 03 */ "HOT FUZZ"
};

const char *fuzz_names[] = {
 /* 00 */ "VICIOUS",
 /* 01 */ "BACON FAT",
 /* 02 */ "BACON BOAT",
 /* 03 */ "BACONMOBILE",
 /* 04 */ "SMOKEY",
 /* 05 */ "PEARL HANDLE",
 /* 06 */ "PERDITION",
 /* 07 */ "PETULANCE",
 /* 08 */ "GLORIOUS MOO",
 /* 09 */ "RADIANCE",

 /* 10 */ "HAWKSBILL",
 /* 11 */ "SAWTOOTH",
 /* 12 */ "CRESCENT MOON",
 /* 13 */ "FALCHION",
 /* 14 */ "SABERTOOTH",
 /* 15 */ "DIRGE",
 /* 16 */ "LANCE",
 /* 17 */ "SPEARTIP",
 /* 18 */ "PILUM",
 /* 19 */ "CALTROPS",

 /* 20 */ "GLADIUS",
 /* 21 */ "SCUTUM",
 /* 22 */ "FLETCHING",
 /* 23 */ "LONGBOW",
 /* 24 */ "ARBALEST",
 /* 25 */ "CRANEQUIN",
 /* 26 */ "CANNONEER",
 /* 27 */ "BLOCKADE",
 /* 28 */ "STOCKADE",
 /* 29 */ "BLOODY LIP",

 /* 30 */ "FIRE DANCER",
 /* 31 */ "CRYSTAL ROSE",
 /* 32 */ "STONE RHINO",
 /* 33 */ "GILGAMESH",
 /* 34 */ "MARS",
 /* 35 */ "ILL PORTENT",
 /* 36 */ "GRAVEROBBER",
 /* 37 */ "WIDOWMAKER",
 /* 38 */ "SLIPSTREAM",
 /* 39 */ "CHIEF BONK",

 /* 40 */ "HARRIER",
 /* 41 */ "CLAYMORE",
 /* 42 */ "FLAMBERGE",
 /* 43 */ "WAR HAMMER",
 /* 44 */ "SLEDGEHAMMER",
 /* 45 */ "DOOM GUARD",
 /* 46 */ "LAWGIVERS",
 /* 47 */ "AMENDMENT",
 /* 48 */ "DONUT EXPRESS",
 /* 49 */ "BEARCLAW"
};

const char *menu_titles[] = {
 /* 00 */ ".",
 /* 01 */ "BASIC PIMPOLOGY",
 /* 02 */ "EXPERT PIMPONOMETRY",
 /* 03 */ "PIMP MY STARSHIP",
 /* 04 */ "PIMPTOPIA",
 /* 05 */ ".",
 /* 06 */ ".",
 /* 07 */ ".",
 /* 08 */ ".",
 /* 09 */ "THE LURVE BOAT",

 /* 10 */ "SCOUT",
 /* 11 */ "INTERCEPTOR",
 /* 12 */ "SENTINEL",
 /* 13 */ "DEVASTATOR",
 /* 14 */ ".",
 /* 15 */ ".",
 /* 16 */ ".",
 /* 17 */ ".",
 /* 18 */ ".",
 /* 19 */ ".",

 /* 20 */ "CAUGHT BY VOIDSTAR",
 /* 21 */ "WARP COIL",
 /* 22 */ "SAVORY SALVAGE",
 /* 23 */ ".",
 /* 24 */ ".",
 /* 25 */ ".",
 /* 26 */ ".",
 /* 27 */ "A PIMP IN NEED",
 /* 28 */ "CELESTIAL FIRE",
 /* 29 */ "A WINNAR IS YOU"
};

const char *menu_options[] = {
 /* 00 */ "FIGHT IT OUT",
 /* 01 */ "OFFER BRIBE",
 /* 02 */ "GTFO",
 /* 03 */ "",
 /* 04 */ "",
 /* 05 */ "RECRUIT VAMPIMP",
 /* 06 */ "RECRUIT PSYCHOCAT",
 /* 07 */ "LEAVE",
 /* 08 */ "",
 /* 09 */ "",

 /* 10 */ "RECRUIT LUVBOT",
 /* 11 */ "RECRUIT SIREN",
 /* 12 */ "LEAVE",
 /* 13 */ "",
 /* 14 */ "",
 /* 15 */ "UPGRADE CREW",
 /* 16 */ "UPGRADE CARGO",
 /* 17 */ "UPGRADE SCANNER",
 /* 18 */ "UPGRADE ENGINE",
 /* 19 */ "LEAVE",

 /* 20 */ "PICKIP",
 /* 21 */ "DROPOFF",
 /* 22 */ "LEAVE",
 /* 23 */ "",
 /* 24 */ "OK",
 /* 25 */ "",
 /* 26 */ "",
 /* 27 */ "",
 /* 28 */ "",
 /* 29 */ "",

 /* 30 */ "START GAME",
 /* 31 */ "TUTORIAL",
 /* 32 */ "EXIT",
 /* 33 */ "",
 /* 34 */ "",
 /* 35 */ "",
 /* 36 */ "",
 /* 37 */ "",
 /* 38 */ "",
 /* 39 */ "",

 /* 40 */ "CONTINUE",
 /* 41 */ "",
 /* 42 */ "",
 /* 43 */ "",
 /* 44 */ "",
 /* 45 */ "",
 /* 46 */ "",
 /* 47 */ "",
 /* 48 */ "",
 /* 49 */ ""
};

const char *planet_names[] = {
 /* 00 */ "AQUIUS",
 /* 01 */ "BOTRAX",
 /* 02 */ "VORRUN",
 /* 03 */ "CYRIE II",
 /* 04 */ "VRIES",
 /* 05 */ "CALDYN",
 /* 06 */ "UMARTHE",
 /* 07 */ "JURUYO",
 /* 08 */ "CHAULDRA",
 /* 09 */ "GALEA",

 /* 10 */ "YARMAE",
 /* 11 */ "SULOANE",
 /* 12 */ "CORNWYN",
 /* 13 */ "PLURIAN",
 /* 14 */ "WARDEN",
 /* 15 */ "AMBRITE",
 /* 16 */ "BRINE",
 /* 17 */ "KRUB",
 /* 18 */ "DRESBAN",
 /* 19 */ "HYLAR",

 /* 20 */ "WELTARTH",
 /* 21 */ "MEOUCH",
 /* 22 */ "JUNKLI",
 /* 23 */ "ARX II",
 /* 24 */ "STHOTE",
 /* 25 */ "FINNEA",
 /* 26 */ "GOLUM",
 /* 27 */ "ORTHRUS",
 /* 28 */ "RHOGUL",
 /* 29 */ "NOOBZ",

 /* 30 */ "BEWBS II",
 /* 31 */ "MURPLE",
 /* 32 */ "DRAUGG",
 /* 33 */ "UMLAUTE",
 /* 34 */ "CLOVER",
 /* 35 */ "EPYXE",
 /* 36 */ "HROTHEN",
 /* 37 */ "IXIAN",
 /* 38 */ "LLAMAZ",
 /* 39 */ "ZEBULON",

 /* 40 */ "REKOSS",
 /* 41 */ "JINXE",
 /* 42 */ "YLLONE",
 /* 43 */ "MELLOW",
 /* 44 */ "SUDMEAD",
 /* 45 */ "BROHEMIA",
 /* 46 */ "RAYLIBRA",
 /* 47 */ "EMOJIMIA",
 /* 48 */ "DAGON",
 /* 49 */ "CTUHGA",

 /* 50 */ "QUAGLO",
 /* 51 */ "PRUUSTE",
 /* 52 */ "WINGUARD",
 /* 53 */ "OBLO PER",
 /* 54 */ "RETAAN II",
 /* 55 */ "IDEONE",
 /* 56 */ "UNDINE",
 /* 57 */ "TABLURAE",
 /* 58 */ "YOJ TUKK",
 /* 59 */ "EVENSTAR",

 /* 60 */ "ASLOBIA",
 /* 61 */ "LITHEREAL",
 /* 62 */ "SNOO SNOO",
 /* 63 */ "KARBO IV",
 /* 64 */ "DERVISHNU",
 /* 65 */ "JATI SAL",
 /* 66 */ "FAUST",
 /* 67 */ "HORDLUUD",
 /* 68 */ "GOATIES",
 /* 69 */ "LORGNAX",

 /* 70 */ "ZANZIBUUL",
 /* 71 */ "MYTHONAUT",
 /* 72 */ "XINDOL B",
 /* 73 */ "NIMBUS",
 /* 74 */ "KLAATU",
 /* 75 */ "BARADA",
 /* 76 */ "NIKTO",
 /* 77 */ "VORTHNOD",
 /* 78 */ "CANTEDALE",
 /* 79 */ "POONTOPIA",

};



const char *cargo_names[] = {
 /* 00 */ "POIDS",
 /* 01 */ "BIPEDS",
 /* 02 */ "CATGIRLS",
 /* 03 */ "OOZE",
 /* 04 */ ".",
 /* 05 */ ".",
 /* 06 */ ".",
 /* 07 */ ".",
 /* 08 */ ".",
 /* 09 */ "."
};


#ifdef USE_TEXTBOX
    textbox_struct textbox[MAX_TEXTBOX];

    float box_tex_x = 0;              // For anchoring happy texture at game over summary
    float box_tex_y = 0;              //
    int box_update  = 0;              //

    const char *textbox_messages[] = {
 /* 00 */ ".",
 /* 01 */ "This is your ship. Left Click on a blue node to select it. Click again to travel there.",
 /* 02 */ "Hold the right mouse button to move the camera. Mouse wheel zooms. Click wheel to reset zoom.",
 /* 03 */ "Click on a planet while orbiting it to trade. You can pick up employees (aka cargo) here.",
 /* 04 */ "Trade with this planet and drop off the employees to make a little money. All cargo will be unloaded at once.",
 /* 05 */ "Each planet has a type of cargo they want. You get a 3x bonus for those employees. Pay attention and make more money with less risk!",
 /* 06 */ "Half of your money can be spent. The other half goes to your savings. The game ends when you have 75K in savings, or all crew are dead.",
 /* 07 */ "Patrol ships will not attack you if you are not carrying any cargo.",
 /* 08 */ "Green stations offer basic crew members, for a price.",
 /* 09 */ "Purple stations offer advanced crew members, for a price.",
 /* 10 */ "The orange station offers ship upgrades. You can buy upgrades to hold more crew and cargo, and faster engines to help you avoid battles.",
 /* 11 */ "You can see the state of your ship and crew by clicking on the SHIP INFO button",
 /* 12 */ "You can pass a turn by clicking on the PASS TIME button.",
 /* 13 */ "The FUZZ LEVEL indicates how strong the patrol ships will be when they respawn. Each ship level is unique.",
 /* 14 */ "We are giving you some cargo. you get to fight enemies now.",
 /* 15 */ "Scout ships have grunts on board. They are basic enemies.",
 /* 16 */ "Interceptors also carry assault bots. They are specialized to subdue catgirls.",
 /* 17 */ "Sentinels also carry inquisitors. They will debuff your attack and defense, but will not attack.",
 /* 18 */ "Devastators also carry Shield Goons. They have a weak attack, but will automatically buff the entire party defense.",
 /* 19 */ "Now get out there and pimp that intergalactic ass. Press ESC to end the tutorial."
    };

#endif



#ifdef USE_BULLETIN
    bulletin_struct bulletin;

    const char *bulletins[] = {
 /* 00 */ "LEAVE BLANK",
 /* 01 */ "...",
 /* 02 */ "...",
 /* 03 */ "...",
 /* 04 */ "...",
 /* 05 */ "TOP SCORE: 00000666 BY GDR                            ", // Don't modify this string (used by High score)
 /* 06 */ "...",
 /* 07 */ "...",
 /* 08 */ "...",
 /* 09 */ "..."
    };
#endif // USE_BULLETIN






