#include <io.h>
#include <string.h>
#include "Project.h"

// Instead of ifdef'ing the entire file, we'll only knock out the code.
// That way log calls can stay in the project without having to ifdef
// each one. That would suck.



// ------------------------------------------------------------------------------
// UA DOCUMENTATION
//
// NOTE - Appends data to the log file, mimicing printf by accepting certain
//        placeholder tags. Strings, ints, and floats are supported.
//
// NOTE - If FR_LOG_TO_CONSOLE is defined, output is echoed to STDOUT
//
// ------------------------------------------------------------------------------
//
void log(int minimum_priority, const char *parser, ...)
{
 #ifdef USE_LOG
     #ifndef PLATFORM_WEB

 unsigned int i = 0;
 int ent    = 0;
 double dub = 0.0;
 char *strang;

 if(flags.log_handle == NULL) { return; }

 if(flags.log_level < minimum_priority) { return; }

 // Init and start the variable argument system
 //
 va_list ap;
 va_start(ap, parser);


 for(i=0; i<strlen(parser); i++) {
     if(parser[i] == 37) {
         switch(parser[i+1]) {
             case 83: // S or s
            case 115:
                      strang = va_arg(ap, char *);
                      fprintf(flags.log_handle, "%s", strang);

                      #ifdef LOG_TO_CONSOLE
                      printf("%s", strang);
                      #endif
                      break;

             case 68: // D or d
            case 100:
                      ent = va_arg(ap, int);
                      fprintf(flags.log_handle, "%d", ent);

                      #ifdef LOG_TO_CONSOLE
                      printf("%d", ent);
                      #endif
                      break;

             case 70: // F or f
            case 102:
                      dub = va_arg(ap, double);
                      fprintf(flags.log_handle, "%f", dub);

                      #ifdef LOG_TO_CONSOLE
                      printf("%f", dub);
                      #endif
                      break;

             case 37: // % (what I really wanted)
                      fputc(37, flags.log_handle);

                      #ifdef LOG_TO_CONSOLE
                      printf("%%");
                      #endif
                      break;
                             }

         i++;
                         }

     else {
         fputc(parser[i], flags.log_handle);

         #ifdef LOG_TO_CONSOLE
         printf("%c", parser[i]);
         #endif
          }
                                 }

 va_end(ap);

 fprintf(flags.log_handle, "\n");
 fflush(flags.log_handle);

 #ifdef LOG_TO_CONSOLE
 printf("\n");
 #endif

 #endif
 #endif

 return;
}




void open_log()
{
 #ifdef USE_LOG
     #ifndef PLATFORM_WEB

         // This will clear out an old log file
         //
         if(access("__LOG.txt", F_OK) == 0) { remove("__LOG.txt"); }

         flags.log_handle = NULL;
         flags.log_handle = fopen("__LOG.txt", "a+");

     #endif
 #endif

 return;
}




void close_log()
{
 #ifdef USE_LOG
     #ifndef PLATFORM_WEB

         if(flags.log_handle != NULL) { fclose(flags.log_handle); }

     #endif
 #endif

 return;
}



