#include "Project.h"




void open_menu(int slot)
{
 if(slot < 0 || slot >= MAX_MENUS) { log(LOG_ALWAYS, "Slot OOB in call to %s. Slot = %d", __func__, slot); return; }

 menus[slot].enabled     = 1;
 menus[slot].open        = 1;
 menus[slot].close       = 0;
 menus[slot].anim_linear = 0.0;
 menus[slot].anim        = 0.0;

 return;
}




void close_menu(int slot)
{
 if(slot < 0 || slot >= MAX_MENUS) { log(LOG_ALWAYS, "Slot OOB in call to %s. Slot = %d", __func__, slot); return; }

 menus[slot].enabled     = 1;
 menus[slot].open        = 0;
 menus[slot].close       = 1;

 // NB: If player closes a menu while it's still opening,
 //     we'll leave the anim vars unchanged so it gets a bumpless transition
 //     from opening to closing

 return;
}





void define_buttons()
{
 int slot = 0;

 buttons[slot].enabled      = 1;
 buttons[slot].two_line     = 1;
 buttons[slot].pos.x        = 10;
 buttons[slot].pos.y        = SCREEN_H - 84;
 buttons[slot].w            = 140;
 buttons[slot].h            = 72;
 buttons[slot].font         = font2;
 buttons[slot].font_scaling = 4.0;
 buttons[slot].font_spacing = 4.0;

 sprintf(buttons[slot].line_1, "PASS");
 sprintf(buttons[slot].line_2, "TIME");


 slot = 1;
 buttons[slot].enabled      = 1;
 buttons[slot].two_line     = 1;
 buttons[slot].pos.x        = SCREEN_W - 150;
 buttons[slot].pos.y        = SCREEN_H - 84;
 buttons[slot].w            = 140;
 buttons[slot].h            = 72;
 buttons[slot].font         = font2;
 buttons[slot].font_scaling = 4.0;
 buttons[slot].font_spacing = 4.0;

 sprintf(buttons[slot].line_1, "SHIP");
 sprintf(buttons[slot].line_2, "INFO");

 return;
}




// NOTE: Just a big, fugly routine where we set a bunch of parameters
//       It's only necessary to define params that deviate from default
//
void define_menus()
{
 int slot = 0;

 // Menu 1 - Fuzz patrol menu
 //
 slot = 1;
 menus[slot].pos.x        = 100;
 menus[slot].pos.y        = 100;
 menus[slot].opt_offset.x = 20;
 menus[slot].opt_offset.y = 20;
 menus[slot].portrait     = 1;
 menus[slot].opt_spacing  = 10;
 menus[slot].opt_scaling  = 3.0;
 menus[slot].opt_height   = 12.0;
 menus[slot].opt_width    = 1.94;
 menus[slot].opt_color    = 48.0;
 menus[slot].opt_alpha    = 0.50;
 menus[slot].off_alpha    = 0.50;
 menus[slot].opt_range    = 10.0;
 menus[slot].num_options  = 3;
 menus[slot].options[0]   = 0;
 menus[slot].options[1]   = 1;
 menus[slot].options[2]   = 2;
 menus[slot].title        = 0;

 menus[slot].on_text      = WHITE;
 menus[slot].off_text     = WHITE;
 menus[slot].inv_text     = MAROON;
 menus[slot].band_color   = SKY_BLUE;

 menus[slot].opt_font   = font1;
 menus[slot].title_font = font1;


 // Menu 2 - PimpStation menu
 //
 slot = 2;
 menus[slot].pos.x        = 100;
 menus[slot].pos.y        = 100;
 menus[slot].opt_offset.x = 20;
 menus[slot].opt_offset.y = 20;
 menus[slot].portrait     = 5;
 menus[slot].opt_spacing  = 10;
 menus[slot].opt_scaling  = 3.0;
 menus[slot].opt_height   = 12.0;
 menus[slot].opt_width    = 1.94;
 menus[slot].opt_color    = 48.0;
 menus[slot].opt_alpha    = 0.50;
 menus[slot].off_alpha    = 0.50;
 menus[slot].opt_range    = 10.0;
 menus[slot].num_options  = 3;
 menus[slot].options[0]   = 5;
 menus[slot].options[1]   = 6;
 menus[slot].options[2]   = 7;
 menus[slot].title        = 1;

 menus[slot].on_text      = WHITE;
 menus[slot].off_text     = WHITE;
 menus[slot].inv_text     = MAROON;
 menus[slot].band_color   = MENU_ROSE;

 menus[slot].opt_font     = font1;
 menus[slot].title_font   = font1;

 menus[slot].extras       = 1;      // Pimpstation summary panel


 // Menu 3 - Advanced Pimping Menu
 //
 slot = 3;
 menus[slot].pos.x        = 100;
 menus[slot].pos.y        = 100;
 menus[slot].opt_offset.x = 20;
 menus[slot].opt_offset.y = 20;
 menus[slot].portrait     = 6;
 menus[slot].opt_spacing  = 10;
 menus[slot].opt_scaling  = 3.0;
 menus[slot].opt_height   = 12.0;
 menus[slot].opt_width    = 1.94;
 menus[slot].opt_color    = 48.0;
 menus[slot].opt_alpha    = 0.50;
 menus[slot].off_alpha    = 0.50;
 menus[slot].opt_range    = 10.0;
 menus[slot].num_options  = 3;
 menus[slot].options[0]   = 10;
 menus[slot].options[1]   = 11;
 menus[slot].options[2]   = 12;
 menus[slot].title        = 2;

 menus[slot].on_text      = WHITE;
 menus[slot].off_text     = WHITE;
 menus[slot].inv_text     = MAROON;
 menus[slot].band_color   = MENU_VIOLET;

 menus[slot].opt_font     = font1;
 menus[slot].title_font   = font1;

 menus[slot].extras       = 2;      // Advanced Pimping summary panel


 // Menu 4 - Pimp my Starship menu
 //
 slot = 4;
 menus[slot].pos.x        = 100;
 menus[slot].pos.y        = 100;
 menus[slot].opt_offset.x = 20;
 menus[slot].opt_offset.y = 20;
 menus[slot].portrait     = 7;
 menus[slot].opt_spacing  = 11;
 menus[slot].opt_scaling  = 3.0;
 menus[slot].opt_height   = 13.0;
 menus[slot].opt_width    = 1.94;
 menus[slot].opt_color    = 48.0;
 menus[slot].opt_alpha    = 0.50;
 menus[slot].off_alpha    = 0.50;
 menus[slot].opt_range    = 10.0;
 menus[slot].num_options  = 5;
 menus[slot].options[0]   = 15;
 menus[slot].options[1]   = 16;
 menus[slot].options[2]   = 17;
 menus[slot].options[3]   = 18;
 menus[slot].options[4]   = 19;
 menus[slot].title        = 3;

 menus[slot].on_text      = WHITE;
 menus[slot].off_text     = WHITE;
 menus[slot].inv_text     = MAROON;
 menus[slot].band_color   = MENU_PEACH;

 menus[slot].opt_font     = font1;
 menus[slot].title_font   = font1;

 menus[slot].extras       = 3;      // Advanced Pimping summary panel



 // Menu 5 - Cargo menu
 //
 slot = 5;
 menus[slot].pos.x        = 100;
 menus[slot].pos.y        = 100;
 menus[slot].opt_offset.x = 20;
 menus[slot].opt_offset.y = 20;
 menus[slot].portrait     = 5;
 menus[slot].opt_spacing  = 10;
 menus[slot].opt_scaling  = 3.0;
 menus[slot].opt_height   = 12.0;
 menus[slot].opt_width    = 1.94;
 menus[slot].opt_color    = 48.0;
 menus[slot].opt_alpha    = 0.50;
 menus[slot].off_alpha    = 0.50;
 menus[slot].opt_range    = 10.0;
 menus[slot].num_options  = 3;
 menus[slot].options[0]   = 20;
 menus[slot].options[1]   = 21;
 menus[slot].options[2]   = 22;
 menus[slot].title        = -1;

 menus[slot].on_text      = WHITE;
 menus[slot].off_text     = WHITE;
 menus[slot].inv_text     = MAROON;
 menus[slot].band_color   = GRAY;

 menus[slot].opt_font     = font1;
 menus[slot].title_font   = font1;

 menus[slot].extras       = 4;      // Cargo summary panel




 // Menu 9 - Ship Menu
 //
 slot = 9;
 menus[slot].pos.x        = 100;
 menus[slot].pos.y        = 100;
 menus[slot].opt_offset.x = 20;
 menus[slot].opt_offset.y = 20;
 menus[slot].portrait     = 9;
 menus[slot].num_options  = 0;
 menus[slot].title        = 9;
 menus[slot].opt_alpha    = 0.50;
 menus[slot].off_alpha    = 0.50;
 menus[slot].opt_font     = font1;
 menus[slot].title_font   = font1;
 menus[slot].band_color   = BLACK;
 menus[slot].extras       = 9;      // Your Ship summary panel



 // Menu 20 - Voidstar event
 //
 slot = 20;
 menus[slot].pos.x        = 100;
 menus[slot].pos.y        = 100;
 menus[slot].opt_offset.x = 20;
 menus[slot].opt_offset.y = 380;
 menus[slot].portrait     = 20;
 menus[slot].opt_spacing  = 10;
 menus[slot].opt_scaling  = 3.0;
 menus[slot].opt_height   = 12.0;
 menus[slot].opt_width    = 1.94;
 menus[slot].opt_color    = 48.0;
 menus[slot].opt_alpha    = 0.50;
 menus[slot].off_alpha    = 0.50;
 menus[slot].opt_range    = 10.0;
 menus[slot].num_options  = 1;
 menus[slot].options[0]   = 24;
 menus[slot].title        = 20;

 menus[slot].on_text      = WHITE;
 menus[slot].off_text     = WHITE;
 menus[slot].inv_text     = MAROON;
 menus[slot].band_color   = VOID_PINK;

 menus[slot].opt_font     = font1;
 menus[slot].title_font   = font1;

 menus[slot].extras       = 20;      // Voidstar summary



 // Menu 21 - Warp Coil event
 //
 slot = 21;
 menus[slot].pos.x        = 100;
 menus[slot].pos.y        = 100;
 menus[slot].opt_offset.x = 20;
 menus[slot].opt_offset.y = 380;
 menus[slot].portrait     = 21;
 menus[slot].opt_spacing  = 10;
 menus[slot].opt_scaling  = 3.0;
 menus[slot].opt_height   = 12.0;
 menus[slot].opt_width    = 1.94;
 menus[slot].opt_color    = 48.0;
 menus[slot].off_alpha    = 0.50;
 menus[slot].opt_alpha    = 0.30;
 menus[slot].opt_range    = 10.0;
 menus[slot].num_options  = 1;
 menus[slot].options[0]   = 24;
 menus[slot].title        = 21;

 menus[slot].on_text      = WHITE;
 menus[slot].off_text     = WHITE;
 menus[slot].inv_text     = MAROON;
 menus[slot].band_color   = WARP_GREEN;

 menus[slot].opt_font     = font1;
 menus[slot].title_font   = font1;

 menus[slot].extras       = 21;      // Warp Coil summary



 // Menu 22 - Salvage event
 //
 slot = 22;
 menus[slot].pos.x        = 100;
 menus[slot].pos.y        = 100;
 menus[slot].opt_offset.x = 20;
 menus[slot].opt_offset.y = 380;
 menus[slot].portrait     = 22;
 menus[slot].opt_spacing  = 10;
 menus[slot].opt_scaling  = 3.0;
 menus[slot].opt_height   = 12.0;
 menus[slot].opt_width    = 1.94;
 menus[slot].opt_color    = 48.0;
 menus[slot].opt_alpha    = 0.50;
 menus[slot].off_alpha    = 0.50;
 menus[slot].opt_range    = 10.0;
 menus[slot].num_options  = 1;
 menus[slot].options[0]   = 24;
 menus[slot].title        = 22;

 menus[slot].on_text      = WHITE;
 menus[slot].off_text     = WHITE;
 menus[slot].inv_text     = MAROON;
 menus[slot].band_color   = SALVAGE_PURPLE;

 menus[slot].opt_font     = font1;
 menus[slot].title_font   = font1;

 menus[slot].extras       = 22;      // Salvage summary



 // Menu 27 - Rescue Event
 //
 slot = 27;
 menus[slot].pos.x        = 100;
 menus[slot].pos.y        = 100;
 menus[slot].opt_offset.x = 20;
 menus[slot].opt_offset.y = 380;
 menus[slot].portrait     = 34;
 menus[slot].opt_spacing  = 10;
 menus[slot].opt_scaling  = 3.0;
 menus[slot].opt_height   = 12.0;
 menus[slot].opt_width    = 1.94;
 menus[slot].opt_color    = 48.0;
 menus[slot].opt_alpha    = 0.50;
 menus[slot].off_alpha    = 0.50;
 menus[slot].opt_range    = 10.0;
 menus[slot].num_options  = 1;
 menus[slot].options[0]   = 24;
 menus[slot].title        = 27;

 menus[slot].on_text      = WHITE;
 menus[slot].off_text     = WHITE;
 menus[slot].inv_text     = MAROON;
 menus[slot].band_color   = SALVAGE_PURPLE;

 menus[slot].opt_font     = font1;
 menus[slot].title_font   = font1;

 menus[slot].extras       = 27;      // Salvage summary



 // Menu 28 - Celestial Fire Event
 //
 slot = 28;
 menus[slot].pos.x        = 100;
 menus[slot].pos.y        = 100;
 menus[slot].opt_offset.x = 20;
 menus[slot].opt_offset.y = 380;
 menus[slot].portrait     = 35;
 menus[slot].opt_spacing  = 10;
 menus[slot].opt_scaling  = 3.0;
 menus[slot].opt_height   = 12.0;
 menus[slot].opt_width    = 1.94;
 menus[slot].opt_color    = 48.0;
 menus[slot].opt_alpha    = 0.50;
 menus[slot].off_alpha    = 0.50;
 menus[slot].opt_range    = 10.0;
 menus[slot].num_options  = 1;
 menus[slot].options[0]   = 24;
 menus[slot].title        = 28;

 menus[slot].on_text      = WHITE;
 menus[slot].off_text     = WHITE;
 menus[slot].inv_text     = MAROON;
 menus[slot].band_color   = SALVAGE_PURPLE;

 menus[slot].opt_font     = font1;
 menus[slot].title_font   = font1;

 menus[slot].extras       = 28;      // Salvage summary



 // Menu 29 - YOU WIN EVENT
 //
 slot = 29;
 menus[slot].pos.x        = 100;
 menus[slot].pos.y        = 100;
 menus[slot].opt_offset.x = 20;
 menus[slot].opt_offset.y = 380;
 menus[slot].portrait     = 21;
 menus[slot].opt_spacing  = 10;
 menus[slot].opt_scaling  = 3.0;
 menus[slot].opt_height   = 12.0;
 menus[slot].opt_width    = 1.94;
 menus[slot].opt_color    = 48.0;
 menus[slot].off_alpha    = 0.50;
 menus[slot].opt_alpha    = 0.30;
 menus[slot].opt_range    = 10.0;
 menus[slot].num_options  = 1;
 menus[slot].options[0]   = 24;
 menus[slot].title        = 29;

 menus[slot].on_text      = WHITE;
 menus[slot].off_text     = WHITE;
 menus[slot].inv_text     = MAROON;
 menus[slot].band_color   = SALVAGE_PURPLE;

 menus[slot].opt_font     = font1;
 menus[slot].title_font   = font1;

 menus[slot].extras       = 29;      // YOU WIN SUMMARY




 // Menu 30 - Main Menu
 //
 slot = 30;
 menus[slot].options_only = 1;
 menus[slot].opt_offset.x = 0;
 menus[slot].opt_offset.y = 0;
 menus[slot].portrait     = -1;
 menus[slot].opt_spacing  = 10;
 menus[slot].opt_scaling  = 3.0;
 menus[slot].opt_height   = 12.0;
 menus[slot].opt_width    = 1.94;
 menus[slot].opt_color    = 48.0;
 menus[slot].opt_alpha    = 0.50;
 menus[slot].off_alpha    = 0.50;
 menus[slot].opt_range    = 10.0;
 menus[slot].num_options  = 3;
 menus[slot].options[0]   = 30;
 menus[slot].options[1]   = 31;
 menus[slot].options[2]   = 32;
 menus[slot].title        = -1;

 menus[slot].on_text      = PINK;
 menus[slot].off_text     = LIGHT_GRAY;
 menus[slot].off_color    = BLACK;

 menus[slot].opt_font     = font1;
 menus[slot].title_font   = font1;
 menus[slot].extras       = 0;

 menus[slot].pos.x        = (SCREEN_W / 2) - ((SCREEN_W / menus[slot].opt_width) / 2);
 menus[slot].pos.y        = SCREEN_H - 370;



 // Menu 31 - Summary
 //
 slot = 31;
 menus[slot].options_only = 1;
 menus[slot].opt_offset.x = 0;
 menus[slot].opt_offset.y = 0;
 menus[slot].portrait     = -1;
 menus[slot].opt_spacing  = 10;
 menus[slot].opt_scaling  = 3.0;
 menus[slot].opt_height   = 12.0;
 menus[slot].opt_width    = 1.94;
 menus[slot].opt_color    = 48.0;
 menus[slot].opt_alpha    = 0.50;
 menus[slot].off_alpha    = 0.50;
 menus[slot].opt_range    = 10.0;
 menus[slot].num_options  = 1;
 menus[slot].options[0]   = 40;
 menus[slot].title        = -1;

 menus[slot].on_text      = PINK;
 menus[slot].off_text     = LIGHT_GRAY;
 menus[slot].off_color    = BLACK;

 menus[slot].opt_font     = font1;
 menus[slot].title_font   = font1;
 menus[slot].extras       = 0;

 menus[slot].pos.x        = (SCREEN_W / 2) - ((SCREEN_W / menus[slot].opt_width) / 2);
 menus[slot].pos.y        = SCREEN_H - 100;

 return;
}




void draw_menu_extras(int slot)
{
 if(slot < 0 || slot >= MAX_MENUS) { log(LOG_ALWAYS, "Slot OOB in call to %s. Slot = %d", __func__, slot); return; }

 int i           = 0;
 int j           = 0;
 int y_pos       = 0;
 int x_pos       = 0;
 int total       = 0;
 int calc        = 0;
 int hp_calc     = 0;
 int orbit       = ships[0].orbiting;
 int bonus_rate  = 3;
 Vector2 panel   = { 0 };
 Vector2 p_size  = { 0 };
 float alpha     = 1.0;
 float port_w    = 160 * 3;
 float port_h    = 160 * 3;

 char blergh[40];

 Color crewset[4]    = { CREW_ORANGE, CREW_BLUE, CREW_GREEN, CREW_PURPLE  };
 Color healthset[4]  = { CARGO_RED, CREW_ORANGE, CARGO_YELLOW, CREW_GREEN };

 switch(menus[slot].extras) {
     case 1: // PimpStation summary panel
             panel.x = menus[slot].pos.x + port_w + 30;
             panel.y = menus[slot].pos.y + port_h + 30;
             p_size.x = 940;
             p_size.y = 300;
             alpha = menus[slot].anim;
             DrawRectangleGradientH(panel.x, panel.y, p_size.x, p_size.y, Fade(menus[slot].band_color, alpha), BLANK);

             if(flags.menu_pos > -1 && flags.menu_pos < 2) {
                 if(flags.menu_pos == 0) { // Vampimp
                     sprintf(blergh, "RECRUITMENT COST: %d", crew_cost[0]);
                     justify_text_l(blergh, panel.x + 14, panel.y + 14, font2, BLACK, 4.0, 4.0);
                     justify_text_l(blergh, panel.x + 10, panel.y + 10, font2, WHITE, 4.0, 4.0);

                     sprintf(blergh, " MONEY LEFT OVER: %d", flags.coffer - crew_cost[0]);
                     justify_text_l(blergh, panel.x + 14, panel.y + 46, font2, BLACK, 4.0, 4.0);
                     justify_text_l(blergh, panel.x + 10, panel.y + 42, font2, CHILL_CYAN, 4.0, 4.0);

                     justify_text_l("STANDARD ALL PURPOSE UNIT", panel.x + 14, panel.y + 94, font2, BLACK, 4.0, 4.0);
                     justify_text_l("STANDARD ALL PURPOSE UNIT", panel.x + 10, panel.y + 90, font2, WHITE, 4.0, 4.0);

                     justify_text_l("ALL STATS NOMINAL", panel.x + 14, panel.y + 126, font2, BLACK, 4.0, 4.0);
                     justify_text_l("ALL STATS NOMINAL", panel.x + 10, panel.y + 122, font2, WHITE, 4.0, 4.0);

                     justify_text_l("WEAK TO PSIONIC ATTACKS", panel.x + 14, panel.y + 158, font2, BLACK, 4.0, 4.0);
                     justify_text_l("WEAK TO PSIONIC ATTACKS", panel.x + 10, panel.y + 154, font2, WHITE, 4.0, 4.0);
                                         }

                 if(flags.menu_pos == 1) { // PsychoCat
                     sprintf(blergh, "RECRUITMENT COST: %d", crew_cost[1]);
                     justify_text_l(blergh, panel.x + 14, panel.y + 14, font2, BLACK, 4.0, 4.0);
                     justify_text_l(blergh, panel.x + 10, panel.y + 10, font2, WHITE, 4.0, 4.0);

                     sprintf(blergh, " MONEY LEFT OVER: %d", flags.coffer - crew_cost[1]);
                     justify_text_l(blergh, panel.x + 14, panel.y + 46, font2, BLACK, 4.0, 4.0);
                     justify_text_l(blergh, panel.x + 10, panel.y + 42, font2, CHILL_CYAN, 4.0, 4.0);

                     justify_text_l("ANTI-PERSONNEL CAT GIRL", panel.x + 14, panel.y + 94, font2, BLACK, 4.0, 4.0);
                     justify_text_l("ANTI-PERSONNEL CAT GIRL", panel.x + 10, panel.y + 90, font2, WHITE, 4.0, 4.0);

                     justify_text_l("WEAK DEFENSE. HEAVY ATTACK", panel.x + 14, panel.y + 126, font2, BLACK, 4.0, 4.0);
                     justify_text_l("WEAK DEFENSE. HEAVY ATTACK", panel.x + 10, panel.y + 122, font2, WHITE, 4.0, 4.0);

                     justify_text_l("WEAK TO HORNY ROBOTS", panel.x + 14, panel.y + 158, font2, BLACK, 4.0, 4.0);
                     justify_text_l("WEAK TO HORNY ROBOTS", panel.x + 10, panel.y + 154, font2, WHITE, 4.0, 4.0);
                                         }
                                                           }
             break;

     case 2: // Advanced Pimping summary panel
             panel.x = menus[slot].pos.x + port_w + 30;
             panel.y = menus[slot].pos.y + port_h + 30;
             p_size.x = 940;
             p_size.y = 300;
             alpha = menus[slot].anim;
             DrawRectangleGradientH(panel.x, panel.y, p_size.x, p_size.y, Fade(menus[slot].band_color, alpha), BLANK);

             if(flags.menu_pos > -1 && flags.menu_pos < 2) {
                 if(flags.menu_pos == 0) { // LuvBot
                     sprintf(blergh, "RECRUITMENT COST: %d", crew_cost[2]);
                     justify_text_l(blergh, panel.x + 14, panel.y + 14, font2, BLACK, 4.0, 4.0);
                     justify_text_l(blergh, panel.x + 10, panel.y + 10, font2, WHITE, 4.0, 4.0);

                     sprintf(blergh, " MONEY LEFT OVER: %d", flags.coffer - crew_cost[2]);
                     justify_text_l(blergh, panel.x + 14, panel.y + 46, font2, BLACK, 4.0, 4.0);
                     justify_text_l(blergh, panel.x + 10, panel.y + 42, font2, CHILL_CYAN, 4.0, 4.0);

                     justify_text_l("ASSAULT UNIT FOR RAPID FIRE", panel.x + 14, panel.y + 94, font2, BLACK, 4.0, 4.0);
                     justify_text_l("ASSAULT UNIT FOR RAPID FIRE", panel.x + 10, panel.y + 90, font2, WHITE, 4.0, 4.0);

                     justify_text_l("STRONG HEALTH. SPREAD FIRE", panel.x + 14, panel.y + 126, font2, BLACK, 4.0, 4.0);
                     justify_text_l("STRONG HEALTH. SPREAD FIRE", panel.x + 10, panel.y + 122, font2, WHITE, 4.0, 4.0);

                     justify_text_l("WEAK TO BLASTER FIRE", panel.x + 14, panel.y + 158, font2, BLACK, 4.0, 4.0);
                     justify_text_l("WEAK TO BLASTER FIRE", panel.x + 10, panel.y + 154, font2, WHITE, 4.0, 4.0);
                                         }

                 if(flags.menu_pos == 1) { // Siren
                     sprintf(blergh, "RECRUITMENT COST: %d", crew_cost[3]);
                     justify_text_l(blergh, panel.x + 14, panel.y + 14, font2, BLACK, 4.0, 4.0);
                     justify_text_l(blergh, panel.x + 10, panel.y + 10, font2, WHITE, 4.0, 4.0);

                     sprintf(blergh, " MONEY LEFT OVER: %d", flags.coffer - crew_cost[3]);
                     justify_text_l(blergh, panel.x + 14, panel.y + 46, font2, BLACK, 4.0, 4.0);
                     justify_text_l(blergh, panel.x + 10, panel.y + 42, font2, CHILL_CYAN, 4.0, 4.0);

                     justify_text_l("SPECIALIZED SUPPORT UNIT", panel.x + 14, panel.y + 94, font2, BLACK, 4.0, 4.0);
                     justify_text_l("SPECIALIZED SUPPORT UNIT", panel.x + 10, panel.y + 90, font2, WHITE, 4.0, 4.0);

                     justify_text_l("NO ATTACK. BUFFS AND HEALS", panel.x + 14, panel.y + 126, font2, BLACK, 4.0, 4.0);
                     justify_text_l("NO ATTACK. BUFFS AND HEALS", panel.x + 10, panel.y + 122, font2, WHITE, 4.0, 4.0);

                     justify_text_l("WEAK TO ALL DAMAGE TYPES", panel.x + 14, panel.y + 158, font2, BLACK, 4.0, 4.0);
                     justify_text_l("WEAK TO ALL DAMAGE TYPES", panel.x + 10, panel.y + 154, font2, WHITE, 4.0, 4.0);
                                         }
                                                           }
             break;

     case 3: // Starship Pimping summary panel
             panel.x = menus[slot].pos.x + port_w + 30;
             panel.y = menus[slot].pos.y + port_h + 30;
             p_size.x = 940;
             p_size.y = 300;
             alpha = menus[slot].anim;
             DrawRectangleGradientH(panel.x, panel.y, p_size.x, p_size.y, Fade(menus[slot].band_color, alpha), BLANK);

             if(flags.menu_pos > -1 && flags.menu_pos < 4) {
                 if(flags.menu_pos == 0) { // Crew Upgrade
                     sprintf(blergh, "UPGRADE COST: %d", upgrade_cost[0]);
                     justify_text_l(blergh, panel.x + 14, panel.y + 14, font2, BLACK, 4.0, 4.0);
                     justify_text_l(blergh, panel.x + 10, panel.y + 10, font2, WHITE, 4.0, 4.0);

                     sprintf(blergh, "MONEY LEFT OVER: %d", flags.coffer - upgrade_cost[0]);
                     justify_text_l(blergh, panel.x + 14, panel.y + 46, font2, BLACK, 4.0, 4.0);
                     justify_text_l(blergh, panel.x + 10, panel.y + 42, font2, CHILL_CYAN, 4.0, 4.0);
///                                                             " <- Last character available
                     justify_text_l("INCREASES THE NUMBER OF", panel.x + 14, panel.y + 94, font2, BLACK, 4.0, 4.0);
                     justify_text_l("INCREASES THE NUMBER OF", panel.x + 10, panel.y + 90, font2, WHITE, 4.0, 4.0);

                     justify_text_l("CREW YOU CAN CARRY. THIS", panel.x + 14, panel.y + 126, font2, BLACK, 4.0, 4.0);
                     justify_text_l("CREW YOU CAN CARRY. THIS", panel.x + 10, panel.y + 122, font2, WHITE, 4.0, 4.0);

                     justify_text_l("HELPS SURVIVE BATTLES", panel.x + 14, panel.y + 158, font2, BLACK, 4.0, 4.0);
                     justify_text_l("HELPS SURVIVE BATTLES", panel.x + 10, panel.y + 154, font2, WHITE, 4.0, 4.0);
                                         }

                 if(flags.menu_pos == 1) { // Cargo Upgrade
                     sprintf(blergh, "UPGRADE COST: %d", upgrade_cost[1]);
                     justify_text_l(blergh, panel.x + 14, panel.y + 14, font2, BLACK, 4.0, 4.0);
                     justify_text_l(blergh, panel.x + 10, panel.y + 10, font2, WHITE, 4.0, 4.0);

                     sprintf(blergh, "MONEY LEFT OVER: %d", flags.coffer - upgrade_cost[1]);
                     justify_text_l(blergh, panel.x + 14, panel.y + 46, font2, BLACK, 4.0, 4.0);
                     justify_text_l(blergh, panel.x + 10, panel.y + 42, font2, CHILL_CYAN, 4.0, 4.0);
///                                                             " <- Last character available
                     justify_text_l("INCREASES THE NUMBER OF", panel.x + 14, panel.y + 94, font2, BLACK, 4.0, 4.0);
                     justify_text_l("INCREASES THE NUMBER OF", panel.x + 10, panel.y + 90, font2, WHITE, 4.0, 4.0);

                     justify_text_l("EMPLOYEES YOU CAN CARRY.", panel.x + 14, panel.y + 126, font2, BLACK, 4.0, 4.0);
                     justify_text_l("EMPLOYEES YOU CAN CARRY.", panel.x + 10, panel.y + 122, font2, WHITE, 4.0, 4.0);

                     justify_text_l("CAN IMPROVE TRIP EFFICIENCY", panel.x + 14, panel.y + 158, font2, BLACK, 4.0, 4.0);
                     justify_text_l("CAN IMPROVE TRIP EFFICIENCY", panel.x + 10, panel.y + 154, font2, WHITE, 4.0, 4.0);
                                         }

                 if(flags.menu_pos == 2) { // Scanner Upgrade
                     sprintf(blergh, "UPGRADE COST: %d", upgrade_cost[2]);
                     justify_text_l(blergh, panel.x + 14, panel.y + 14, font2, BLACK, 4.0, 4.0);
                     justify_text_l(blergh, panel.x + 10, panel.y + 10, font2, WHITE, 4.0, 4.0);

                     sprintf(blergh, "MONEY LEFT OVER: %d", flags.coffer - upgrade_cost[2]);
                     justify_text_l(blergh, panel.x + 14, panel.y + 46, font2, BLACK, 4.0, 4.0);
                     justify_text_l(blergh, panel.x + 10, panel.y + 42, font2, CHILL_CYAN, 4.0, 4.0);
///                                                             " <- Last character available
                     justify_text_l("CONVERTS A STANDARD SCANNER", panel.x + 14, panel.y + 94, font2, BLACK, 4.0, 4.0);
                     justify_text_l("CONVERTS A STANDARD SCANNER", panel.x + 10, panel.y + 90, font2, WHITE, 4.0, 4.0);

                     justify_text_l("INTO AN ADVANCED SCANNER.", panel.x + 14, panel.y + 126, font2, BLACK, 4.0, 4.0);
                     justify_text_l("INTO AN ADVANCED SCANNER.", panel.x + 10, panel.y + 122, font2, WHITE, 4.0, 4.0);

                     justify_text_l("REQUIRES FINDING A SCANNER.", panel.x + 14, panel.y + 158, font2, BLACK, 4.0, 4.0);
                     justify_text_l("REQUIRES FINDING A SCANNER.", panel.x + 10, panel.y + 154, font2, CHILL_CYAN, 4.0, 4.0);
                                         }

                 if(flags.menu_pos == 3) { // Engine Upgrade
                     sprintf(blergh, "UPGRADE COST: %d", upgrade_cost[3]);
                     justify_text_l(blergh, panel.x + 14, panel.y + 14, font2, BLACK, 4.0, 4.0);
                     justify_text_l(blergh, panel.x + 10, panel.y + 10, font2, WHITE, 4.0, 4.0);

                     sprintf(blergh, "MONEY LEFT OVER: %d", flags.coffer - upgrade_cost[3]);
                     justify_text_l(blergh, panel.x + 14, panel.y + 46, font2, BLACK, 4.0, 4.0);
                     justify_text_l(blergh, panel.x + 10, panel.y + 42, font2, CHILL_CYAN, 4.0, 4.0);
///                                                             " <- Last character available
                     justify_text_l("INCREASES THE ODDS OF", panel.x + 14, panel.y + 94, font2, BLACK, 4.0, 4.0);
                     justify_text_l("INCREASES THE ODDS OF", panel.x + 10, panel.y + 90, font2, WHITE, 4.0, 4.0);

                     justify_text_l("ESCAPING BATTLE", panel.x + 14, panel.y + 126, font2, BLACK, 4.0, 4.0);
                     justify_text_l("ESCAPING BATTLE", panel.x + 10, panel.y + 122, font2, WHITE, 4.0, 4.0);
                                         }
                                                           }
             break;

     case 4: // Planet menu
             panel.x = menus[slot].pos.x + port_w + 30;
             panel.y = menus[slot].pos.y + port_h + 30;
             p_size.x = 940;
             p_size.y = 300;
             alpha = menus[slot].anim;
             DrawRectangleGradientH(panel.x, panel.y, p_size.x, p_size.y, Fade(menus[slot].band_color, alpha), BLANK);

                 if(flags.menu_pos == 0) { // Pickup Hoes
                     sprintf(blergh, "PICKUP TYPE: %s", cargo_names[nodes[orbit].cargo_offer]);
                     justify_text_l(blergh, panel.x + 14, panel.y + 14, font2, BLACK, 4.0, 4.0);
                     justify_text_l(blergh, panel.x + 10, panel.y + 10, font2, YELLOW, 4.0, 4.0);

                     sprintf(blergh, "EMPLOYEES AVAILABLE: %d", nodes[orbit].cargo_count);
                     justify_text_l(blergh, panel.x + 14, panel.y + 94, font2, BLACK, 4.0, 4.0);
                     justify_text_l(blergh, panel.x + 10, panel.y + 90, font2, CHILL_CYAN, 4.0, 4.0);

                     sprintf(blergh, "    SLOTS AVAILABLE: %d", flags.cargo_level - flags.cargo_total);
                     justify_text_l(blergh, panel.x + 14, panel.y + 126, font2, BLACK, 4.0, 4.0);
                     justify_text_l(blergh, panel.x + 10, panel.y + 122, font2, CHILL_CYAN, 4.0, 4.0);
                                         }

                 if(flags.menu_pos == 1) { // Dropoff Hoes
                     sprintf(blergh, "WANTED: %s", cargo_names[nodes[orbit].cargo_pref]);
                     justify_text_l(blergh, panel.x + 14, panel.y + 14, font2, BLACK, 4.0, 4.0);
                     justify_text_l(blergh, panel.x + 10, panel.y + 10, font2, YELLOW, 4.0, 4.0);

                     y_pos = 90;
                     for(i=0; i<4; i++) {
                         if(i != nodes[orbit].cargo_offer) {
                             if(i == nodes[orbit].cargo_pref) { total += (ships[0].cargo[i] * cargo_cost[i] * bonus_rate); }
                             else                             { total += (ships[0].cargo[i] * cargo_cost[i]);              }

                             sprintf(blergh, "%02d %s", ships[0].cargo[i], cargo_names[i]);
                             justify_text_l(blergh, panel.x + 14, panel.y + y_pos+4, font2, BLACK, 4.0, 4.0);
                             justify_text_l(blergh, panel.x + 10, panel.y + y_pos, font2, SCORE_ORANGE, 4.0, 4.0);
                             y_pos += 32;
                                                           }
                                        }


                     sprintf(blergh, "COMMISSION: %d", total);
                     justify_text_l(blergh, panel.x + 14, panel.y + 190, font2, BLACK, 4.0, 4.0);
                     justify_text_l(blergh, panel.x + 10, panel.y + 186, font2, YELLOW, 4.0, 4.0);
                                         }
             break;

     case 9: // Ship summary Menu
             panel.x = menus[slot].pos.x + port_w + 65;
             panel.y = menus[slot].pos.y + 20;
             p_size.x = SCREEN_W - ((menus[slot].pos.x + port_w + 100) / 2);
             p_size.y = 300;
             alpha = menus[slot].anim;
             justify_text_xy("SHIP SUMMARY", p_size.x, panel.y, font1, Fade(YELLOW, alpha), 3.0, 3.0);


             sprintf(blergh, "CREW CAPACITY:     OF");
             justify_text_l(blergh, panel.x, panel.y + 70, font2, Fade(WHITE, alpha), 4.0, 4.0);

             sprintf(blergh, "                %02d    %02d", flags.crew_level, MAX_CREW_LEVEL);
             justify_text_l(blergh, panel.x, panel.y + 70, font2, Fade(CHILL_CYAN, alpha), 4.0, 4.0);

             sprintf(blergh, "CARGO CAPACITY:    OF");
             justify_text_l(blergh, panel.x, panel.y + 102, font2, Fade(WHITE, alpha), 4.0, 4.0);

             sprintf(blergh, "                %02d    %02d", flags.cargo_level, MAX_CARGO_LEVEL);
             justify_text_l(blergh, panel.x, panel.y + 102, font2, Fade(CHILL_CYAN, alpha), 4.0, 4.0);

             justify_text_l("ENGINE:", panel.x, panel.y + 166, font2, Fade(WHITE, alpha), 4.0, 4.0);
             if(flags.engine_level) {
                 justify_text_l("                UPGRADED", panel.x, panel.y + 166, font2, Fade(YELLOW, alpha), 4.0, 4.0);
                                    }
             else {
                 justify_text_l("                BASELINE", panel.x, panel.y + 166, font2, Fade(CHILL_CYAN, alpha), 4.0, 4.0);
                  }

             justify_text_l("SCANNER:", panel.x, panel.y + 198, font2, Fade(WHITE, alpha), 4.0, 4.0);
             if(!flags.scanner_level) {
                 justify_text_l("                NONE", panel.x, panel.y + 198, font2, Fade(CHILL_CYAN, alpha), 4.0, 4.0);
                                      }
             if(flags.scanner_level == 1) {
                 justify_text_l("                BASIC", panel.x, panel.y + 198, font2, Fade(CHILL_CYAN, alpha), 4.0, 4.0);
                                          }
             if(flags.scanner_level == 2) {
                 justify_text_l("                ADVANCED", panel.x, panel.y + 198, font2, Fade(YELLOW, alpha), 4.0, 4.0);
                                          }


             // Draw crew manifest (VERY LAZY. SO VERY VERY LAZY... YESSSS)
             //
             x_pos = p_size.x - (20 * ships[0].crew_count);

             for(i=0; i<4; i++) {
                 for(j=0; j<MAX_ACTORS; j++) {
                     if(actors[j].owner == 0 && actors[j].type == i) {
                         calc = scale(actors[j].stamina, 0.0, 90.0, 0.0, 9.0);
                         hp_calc = scale(actors[j].stamina, 0.0, 90.0, 0.0, 3.4);
                         tex_blit_c(tex_8x, (8 * i), 0, x_pos, panel.y + 360, 8, 8, 4.0, Fade(crewset[i], alpha));

                         // Draw health module background, then fill in value
                         //
                         tex_blit(tex_32x, 128, 0, x_pos + 18, panel.y + 310, 6, 15, 0.0, 3.0, Fade(WHITE, alpha));
                         DrawRectangle(x_pos + 15, panel.y + 325 - (3 * calc), 6, (3 * calc), Fade(healthset[hp_calc], alpha));
                         x_pos += 40;
                                                                     }
                                             }
                                }
             break;

    case 20: // Voidstar summary
             panel.x = menus[slot].pos.x + port_w + 65;
             panel.y = menus[slot].pos.y + 20;
             p_size.x = SCREEN_W - ((menus[slot].pos.x + port_w + 100) / 2) - 20;

             shadow_text_xy("YOU FALL INTO THE VOIDSTAR", p_size.x, panel.y + 40,  font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             shadow_text_xy("THE FIELD RIPS APART YOUR",  p_size.x, panel.y + 100, font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             shadow_text_xy("SHIP AND CREW",              p_size.x, panel.y + 160, font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             break;

    case 21: // Warp Coil
             panel.x = menus[slot].pos.x + port_w + 65;
             panel.y = menus[slot].pos.y + 20;
             p_size.x = SCREEN_W - ((menus[slot].pos.x + port_w + 100) / 2) - 20;

             shadow_text_xy("YOU SLIP INTO THE WARP COIL", p_size.x, panel.y + 40,  font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             shadow_text_xy("AND FIND YOURSELF DROPPED",   p_size.x, panel.y + 100, font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             shadow_text_xy("INTO A RANDOM LOCATION",      p_size.x, panel.y + 160, font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             break;

    case 22: // Salvage (Credits)
             panel.x = menus[slot].pos.x + port_w + 65;
             panel.y = menus[slot].pos.y + 20;
             p_size.x = SCREEN_W - ((menus[slot].pos.x + port_w + 100) / 2) - 20;

             shadow_text_xy("YOU HAVE FOUND A DERELICT", p_size.x, panel.y + 40,  font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             shadow_text_xy("SHIP WITH CREDITS STORED",  p_size.x, panel.y + 100, font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             shadow_text_xy("IN THE HOLD",               p_size.x, panel.y + 160, font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             break;

    case 23: // Salvage (Bonus Cargo Hold)
             panel.x = menus[slot].pos.x + port_w + 65;
             panel.y = menus[slot].pos.y + 20;
             p_size.x = SCREEN_W - ((menus[slot].pos.x + port_w + 100) / 2) - 20;

             shadow_text_xy("YOU HAVE FOUND A DERELICT", p_size.x, panel.y + 40,  font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             shadow_text_xy("SHIP WITH A MODULAR",       p_size.x, panel.y + 100, font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             shadow_text_xy("STORAGE HOLD UPGRADE",      p_size.x, panel.y + 160, font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             break;

    case 24: // Salvage (Standard Scanner)
             panel.x = menus[slot].pos.x + port_w + 65;
             panel.y = menus[slot].pos.y + 20;
             p_size.x = SCREEN_W - ((menus[slot].pos.x + port_w + 100) / 2) - 20;

             shadow_text_xy("YOU HAVE FOUND A DERELICT", p_size.x, panel.y + 40,  font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             shadow_text_xy("SHIP WITH A SHORT RANGE",   p_size.x, panel.y + 100, font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             shadow_text_xy("SYSTEM SCANNER",            p_size.x, panel.y + 160, font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             break;

    case 25: // Salvage (Advanced Scanner)
             panel.x = menus[slot].pos.x + port_w + 65;
             panel.y = menus[slot].pos.y + 20;
             p_size.x = SCREEN_W - ((menus[slot].pos.x + port_w + 100) / 2) - 20;

             shadow_text_xy("YOU HAVE FOUND A DERELICT", p_size.x, panel.y + 40,  font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             shadow_text_xy("SHIP WITH A MODULAR",       p_size.x, panel.y + 100, font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             shadow_text_xy("CREW CABIN UPGRADE",        p_size.x, panel.y + 160, font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             break;

    case 26: // Salvage (Health packs and credits)
             panel.x = menus[slot].pos.x + port_w + 65;
             panel.y = menus[slot].pos.y + 20;
             p_size.x = SCREEN_W - ((menus[slot].pos.x + port_w + 100) / 2) - 20;

             shadow_text_xy("YOU HAVE FOUND A DERELICT",  p_size.x, panel.y + 40,  font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             shadow_text_xy("SHIP WITH MEDICAL SUPPLIES", p_size.x, panel.y + 100, font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             shadow_text_xy("AND CREDITS IN THE HOLD",    p_size.x, panel.y + 160, font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             break;

    case 27: // Rescue Event
             panel.x = menus[slot].pos.x + port_w + 65;
             panel.y = menus[slot].pos.y + 20;
             p_size.x = SCREEN_W - ((menus[slot].pos.x + port_w + 100) / 2) - 20;

             shadow_text_xy("YOU HAVE HELPED RESCUE A",   p_size.x, panel.y + 40,  font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             shadow_text_xy("FELLOW VAMPIMP. YOU PICK",   p_size.x, panel.y + 100, font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             shadow_text_xy("UP THEIR CREDITS AND CARGO", p_size.x, panel.y + 160, font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             break;

    case 28: // Celestial Fire
             panel.x = menus[slot].pos.x + port_w + 65;
             panel.y = menus[slot].pos.y + 20;
             p_size.x = SCREEN_W - ((menus[slot].pos.x + port_w + 100) / 2) - 20;

             shadow_text_xy("THE ALIEN ARTIFACT EMITS",    p_size.x, panel.y + 40,  font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             shadow_text_xy("WAVES OF CHARGED PARTICLES.", p_size.x, panel.y + 100, font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             shadow_text_xy("FUZZ SCANNERS ARE OFFLINE",   p_size.x, panel.y + 160, font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             break;

    case 29: // YOU WIN MESSAGE
             panel.x = menus[slot].pos.x + port_w + 65;
             panel.y = menus[slot].pos.y + 20;
             p_size.x = SCREEN_W - ((menus[slot].pos.x + port_w + 100) / 2) - 20;

             shadow_text_xy("YOU HAVE PIMPED THAT ASS",  p_size.x, panel.y + 40,  font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             shadow_text_xy("ACROSS THE GALAXY AND",     p_size.x, panel.y + 100, font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             shadow_text_xy("LIVED TO TELL THE TALE",    p_size.x, panel.y + 160, font1, Fade(WHITE, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);

             shadow_text_xy("ENJOY YOUR RETIREMENT",    p_size.x, panel.y + 260, font1, Fade(YELLOW, alpha), Fade(BLACK, alpha), 4,4, 3.0,3.0);
             break;
                            }

 // Special case for enemy ships
 //
 if(menus[slot].extras >= 100) {
     j = (menus[slot].extras - 100);
     justify_text_xy(ships[j].name, menus[slot].pos.x + (port_w / 2.0) + 4, menus[slot].pos.y + port_h + 84, menus[slot].opt_font, Fade(BLACK, menus[slot].anim), menus[slot].opt_scaling, menus[slot].opt_scaling);
     justify_text_xy(ships[j].name, menus[slot].pos.x + (port_w / 2.0),     menus[slot].pos.y + port_h + 80, menus[slot].opt_font, Fade(YELLOW, menus[slot].anim), menus[slot].opt_scaling, menus[slot].opt_scaling);
                               }
 return;
}






// Move this into its own file
//
void draw_menu(int slot)
{
 if(slot < 0 || slot >= MAX_MENUS) { log(LOG_ALWAYS, "Slot OOB in call to %s. Slot = %d", __func__, slot); return; }

 int i   = 0;
 float w = 0.0;
 float h = 0.0;
 float port_w     = 160.0 * 3.0;
 float port_h     = 160.0 * 3.0;
 float start_y    = 0.0;
 float start_x    = 0.0;
 float y_pos      = 0.0;
 float y_spacing  = 0.0;
 float bar_height = 0.0;
 float bar_width  = 0.0;
 float hue        = 0.0;
 float alpha      = 0.0;

 Vector2 overscan  = { SCREEN_W / 14, SCREEN_H / 14 };

 Vector2 len       = { 0 };
 Color bar_color   = BLANK;
 Color text_color  = BLANK;


 if(menus[slot].options_only) { port_w = 0.0; port_h = 0.0; }


 // Draw horizontal cross band and backing
 //
 if(!menus[slot].options_only) {
 w = SCREEN_W - (menus[slot].pos.x + port_w) + overscan.x + 300;
 w *= menus[slot].anim;

 DrawRectangleGradientH(menus[slot].pos.x + port_w, menus[slot].pos.y, w, port_h, menus[slot].band_color, BLANK);


 w =  menus[slot].pos.x + overscan.x;
 w *= menus[slot].anim;

 DrawRectangleGradientH(menus[slot].pos.x-w, menus[slot].pos.y, w, port_h, BLANK, menus[slot].band_color);



 // Draw vertical cross band and backing
 //
 h = SCREEN_H - (menus[slot].pos.y + port_h) + overscan.y;
 h *= menus[slot].anim;

 DrawRectangleGradientV(menus[slot].pos.x, menus[slot].pos.y + port_h, port_w, h, menus[slot].band_color, BLANK);


 h = menus[slot].pos.y + overscan.y;
 h *= menus[slot].anim;

 DrawRectangleGradientV(menus[slot].pos.x, menus[slot].pos.y-h, port_w, h, BLANK, menus[slot].band_color);
                               }

 // Draw portrait
 //
 if(menus[slot].portrait > -1 && !menus[slot].options_only) {
     DrawTextureEx(tex_port[menus[slot].portrait], menus[slot].pos, 0.0, 3.0, Fade(WHITE, menus[slot].anim));
                                                            }

 // Draw Title block
 // If the title is set to -1, override it with the planet
 // the player is orbiting
 //
 if(!menus[slot].options_only) {
 if(menus[slot].title > -1) {
     justify_text_xy(menu_titles[menus[slot].title], menus[slot].pos.x + (port_w / 2.0) + 4, menus[slot].pos.y + port_h + 24, menus[slot].opt_font, Fade(BLACK, menus[slot].anim), menus[slot].opt_scaling, menus[slot].opt_scaling);
     justify_text_xy(menu_titles[menus[slot].title], menus[slot].pos.x + (port_w / 2.0),     menus[slot].pos.y + port_h + 20, menus[slot].opt_font, Fade(WHITE, menus[slot].anim), menus[slot].opt_scaling, menus[slot].opt_scaling);
                            }
 else {
     if(ships[0].orbiting > -1 && ships[0].orbiting < MAX_NODES) {
     justify_text_xy(nodes[ships[0].orbiting].name, menus[slot].pos.x + (port_w / 2.0) + 4, menus[slot].pos.y + port_h + 24, menus[slot].opt_font, Fade(BLACK, menus[slot].anim), menus[slot].opt_scaling, menus[slot].opt_scaling);
     justify_text_xy(nodes[ships[0].orbiting].name, menus[slot].pos.x + (port_w / 2.0),     menus[slot].pos.y + port_h + 20, menus[slot].opt_font, Fade(WHITE, menus[slot].anim), menus[slot].opt_scaling, menus[slot].opt_scaling);
                                                                 }
      }
                               }

 // Option spacing and bar height are automatically calculated
 //
 y_spacing  = SCREEN_H / menus[slot].opt_spacing;
 bar_height = SCREEN_H / menus[slot].opt_height;
 bar_width  = SCREEN_W / menus[slot].opt_width;


 start_y = menus[slot].pos.y + menus[slot].opt_offset.y;
 start_x = menus[slot].pos.x + menus[slot].opt_offset.x + port_w;

 w   = start_x + (bar_width - len.x) / 2.0;
 len = MeasureTextEx(menus[slot].opt_font, "A", menus[slot].opt_font.baseSize * menus[slot].opt_scaling, menus[slot].opt_scaling);
 h   = (bar_height - len.y) / 2.0;


 // First pass to detect mouse-overs, if mouse controlled
 // This should really go elsewhere
 //
 #ifdef MOUSE_IS_PRIMARY
 if(flags.mouse_menu_check) {
     flags.menu_pos = -1;
     for(i=0; i<menus[slot].num_options; i++) {
         y_pos = start_y + (y_spacing * i);

         if(flags.mouse.x > start_x &&
            flags.mouse.x < (start_x + bar_width) &&
            flags.mouse.y > y_pos &&
            flags.mouse.y < (y_pos + bar_height)) { flags.menu_pos = i; }
                                              }
                            }
 #endif


 // Draw menus options
 //
 for(i=0; i<menus[slot].num_options; i++) {
     y_pos = start_y + (y_spacing * i);

     // Invalid status overrides text color
     //
     if(menus[slot].invalid[i]) {
         text_color = menus[slot].inv_text;

         if(flags.menu_pos == i) {
             hue   = menus[slot].inv_color + sin(TO_RADIANS(anims[4])) * menus[slot].inv_range;
             alpha = (1.0 - menus[slot].inv_alpha) + ((sin(TO_RADIANS(anims[4])) * menus[slot].inv_alpha) / 2);
             alpha *= menus[slot].anim;
             bar_color = ColorFromHSV(hue, 1.0, 1.0);
                                 }
         else {
             bar_color  = menus[slot].off_color;
             alpha      = menus[slot].off_alpha * menus[slot].anim;
              }
                                }
     else {
         hue   = menus[slot].opt_color + sin(TO_RADIANS(anims[4])) * menus[slot].opt_range;
         alpha = (1.0 - menus[slot].opt_alpha) + ((sin(TO_RADIANS(anims[4])) * (menus[slot].opt_alpha) / 4));
         alpha *= menus[slot].anim;
         bar_color = ColorFromHSV(hue, 1.0, 1.0);

         if(flags.menu_pos == i) { text_color = menus[slot].on_text;  }
         else {
             text_color = menus[slot].off_text;
             bar_color  = menus[slot].off_color;
             alpha      = menus[slot].off_alpha * menus[slot].anim;
              }
          }


     DrawRectangle(start_x, y_pos, bar_width, bar_height, Fade(bar_color, alpha));

     justify_text_xy(menu_options[menus[slot].options[i]], w + 4, y_pos + h + 4, menus[slot].opt_font, Fade(BLACK, menus[slot].anim), menus[slot].opt_scaling, menus[slot].opt_scaling);
     justify_text_xy(menu_options[menus[slot].options[i]], w,     y_pos + h,     menus[slot].opt_font, Fade(text_color, menus[slot].anim), menus[slot].opt_scaling, menus[slot].opt_scaling);
                                          }


 // Handle extras
 //
 if(menus[slot].extras) { draw_menu_extras(slot); }

 return;
}




// NOTE: Deactivates menu and initializes to default (safe) values
//
void init_menu(int slot)
{
 if(slot < 0 || slot >= MAX_MENUS) { log(LOG_ALWAYS, "Slot OOB in call to %s. Slot = %d", __func__, slot); return; }

 int i = 0;

 menus[slot].enabled      = 0;
 menus[slot].options_only = 0;
 menus[slot].open         = 0;
 menus[slot].close        = 0;
 menus[slot].pos.x        = 0;
 menus[slot].pos.y        = 0;
 menus[slot].opt_offset.x = 0;
 menus[slot].opt_offset.y = 0;
 menus[slot].portrait     = -1;
 menus[slot].title        = -1;
 menus[slot].num_options  = 0;
 menus[slot].extras       = 0;
 menus[slot].anim         = 0.0;
 menus[slot].band_color   = SKY_BLUE;

 menus[slot].opt_spacing  = 10;
 menus[slot].opt_scaling  = 3.0;
 menus[slot].opt_height   = 12.0;
 menus[slot].opt_width    = 2.0;

 menus[slot].opt_color    = 48.0;
 menus[slot].opt_alpha    = 0.30;
 menus[slot].opt_range    = 20.0;

 menus[slot].inv_color    = 32.0;
 menus[slot].inv_alpha    = 0.30;
 menus[slot].inv_range    = 15.0;

 menus[slot].opt_font     = font1;
 menus[slot].title_font   = font1;

 menus[slot].off_color    = GRAY;
 menus[slot].off_alpha    = 0.40;

 menus[slot].on_text      = WHITE;
 menus[slot].off_text     = WHITE;
 menus[slot].inv_text     = MAROON;

 for(i=0; i<MAX_OPTIONS; i++) {
     menus[slot].options[i] = -1;
     menus[slot].invalid[i] = 0;
                              }

 return;
}




// NOTE: Waits inside a menu until an event is received
//       [flags.in_menu] should already be set before calling this
//
int get_menu_event(int slot)
{
 int event = -1;


 // If active input seen, wait for it to clear
 //
 flags.mouse_menu_check = 1;

 recheck:

 #ifdef MOUSE_IS_PRIMARY
     if(IsMouseButtonDown(MOUSE_BUTTON_LEFT)) {
         do {
             update_and_render();
            } while(IsMouseButtonDown(MOUSE_BUTTON_LEFT));
                                              }
 #endif

 do {
     #ifdef MOUSE_IS_PRIMARY
         if(IsMouseButtonDown(MOUSE_BUTTON_LEFT)) {
             if(flags.menu_pos != -1) { event = flags.menu_pos; }
             else                     { goto recheck; }
                                                  }
     #endif

     update_and_render();
    } while(event == -1);


 flags.mouse_menu_check = 0;

 return(event);
}




// NOTE: Plays a default "error" sound effect
//       and triggers a quick mosaic chirp
//
void error_bleep()
{

 flags.mosaic_chirp = 0.01;
 PlaySound(sfx[201]);

 return;
}





void init_button(int slot)
{
 if(slot < 0 || slot >= MAX_BUTTONS) { log(LOG_ALWAYS, "Slot OOB in call to %s. Slot = %d", __func__, slot); return; }

 buttons[slot].enabled      = 0;
 buttons[slot].two_line     = 0;
 buttons[slot].pos.x        = 0.0;
 buttons[slot].pos.y        = 0.0;
 buttons[slot].line_1[0]    = 0;
 buttons[slot].line_2[0]    = 0;

 buttons[slot].font         = font1;
 buttons[slot].font_scaling = 1.0;
 buttons[slot].font_spacing = 1.0;
 buttons[slot].hover_back   = SCORE_ORANGE;
 buttons[slot].hover_text   = WHITE;

 buttons[slot].idle_back    = GRAY;
 buttons[slot].idle_text    = WHITE;

 return;
}




void draw_button(int slot)
{
 if(slot < 0 || slot >= MAX_BUTTONS) { log(LOG_ALWAYS, "Slot OOB in call to %s. Slot = %d", __func__, slot); return; }

 int i       = 0;
 float w     = buttons[slot].w;
 float h     = buttons[slot].h;
 float y_pos = 0.0;
 float x_pos = 0.0;
 float hue   = 0.0;
 float alpha = 1.0;
 float label_height = 0.0;

 Vector2 len = { 0 };
 Color b_color = BLANK;
 Color t_color = BLANK;

 if(flags.button_pos == slot) {
     b_color = buttons[slot].hover_back;
     t_color = buttons[slot].hover_text;
                              }
 else {
     b_color = buttons[slot].idle_back;
     t_color = buttons[slot].idle_text;
      }

 len = MeasureTextEx(buttons[slot].font, "A", buttons[slot].font.baseSize * buttons[slot].font_scaling, buttons[slot].font_scaling);

 DrawRectangle(buttons[slot].pos.x, buttons[slot].pos.y, w, h, b_color);


 if(buttons[slot].two_line) {
     label_height = (len.y * 2.0) + (buttons[slot].font_scaling * 2);

     x_pos = buttons[slot].pos.x + (buttons[slot].w / 2.0);
     y_pos = buttons[slot].pos.y + (buttons[slot].h / 2.0) - (label_height / 2.0);

     justify_text_xy(buttons[slot].line_1, x_pos + 4, y_pos + 4, buttons[slot].font, BLACK,   buttons[slot].font_scaling, buttons[slot].font_spacing);
     justify_text_xy(buttons[slot].line_1, x_pos,     y_pos,     buttons[slot].font, t_color, buttons[slot].font_scaling, buttons[slot].font_spacing);

     y_pos += (len.y + (buttons[slot].font_scaling * 2));
     justify_text_xy(buttons[slot].line_2, x_pos + 4, y_pos + 4, buttons[slot].font, BLACK,   buttons[slot].font_scaling, buttons[slot].font_spacing);
     justify_text_xy(buttons[slot].line_2, x_pos,     y_pos,     buttons[slot].font, t_color, buttons[slot].font_scaling, buttons[slot].font_spacing);
                            }

 else {

      }

 return;
}




// NOTE: Loops through buttons and sees if a button has been clicked
//       on an active button, and returns that value. Else -1
//
int check_button_events()
{

 if(flags.button_pos != -1 && !flags.m_hold[0]) {
     if(IsMouseButtonDown(MOUSE_BUTTON_LEFT)) {
         flags.m_hold[0] = 1;
         return(flags.button_pos);
                                              }
                                                }

 return(-1);
}
