#include "Project.h"

#include <stdio.h>
#include <unistd.h>
#include <math.h>




// NOTE - Returns one if number is ODD; else zero.
//
int is_odd(int number)
{
 return (number & 1);
}




// NOTE: Returns TRUE if actor slot is valid
//
bool valid_actor(int who)
{

 if(who >= 0 && who < MAX_ACTORS) { return(1); }
 else                             { return(0); }
}





void push_rect(Rectangle *rect, float x, float y, float w, float h)
{

 rect->x      = x;
 rect->y      = y;
 rect->width  = w;
 rect->height = h;

 return;
}






int quick_rand(int range)
{
 // This has to be a double, or the lib shits itself
 //
 double f_range = range;
 float result   = fastR.xoroshiro128p_Range(0.0, f_range);

 return(result);
}





float quick_rand_f(float range)
{
 // This has to be a double, or the lib shits itself
 //
 double f_range = range;
 float result = fastR.xoroshiro128p_Range(0.0, f_range);

 return(result);
}





float rescale(float input, float in_min, float in_max, float out_min, float out_max)
{

 float result = 0.0;

 // NOTE: Need to verify that (in_max - in_min) != 0
 //
 result = ((input - in_min) / (in_max - in_min)) * (out_max - out_min) + out_min;


 return(result);
}





float FR_easing_pop_in(float value, float source_min, float source_max, float scaled_min, float scaled_max, float pop_magnitude)
{
 long double c1      = pop_magnitude;
 long double c3      = c1 + 1.0;
 long double percent = 0.0;
 float final_value   = 0.0;

 if((source_max - source_min) == 0.000) { return(0); } // If used in framework, signal division by zero
 if(value > source_max) { value = source_max; }
 if(value < source_min) { value = source_min; }

 percent     = ((value - source_min) / (source_max - source_min));
 final_value = 1 + (c3 * pow(percent - 1, 3)) + (c1 * pow(percent - 1, 2));

 return((final_value * (scaled_max - scaled_min)) + scaled_min);
}







Color makeacol(unsigned char r, unsigned char g, unsigned char b, unsigned char a)
{
 Color result;

 result.r = r;
 result.g = g;
 result.b = b;
 result.a = a;

 return(result);
}




Color grab_gradient(Color c1, Color c2, float banding, float zero_to_one)
{

 Color value = BLANK;

 float b_factor;
 float zto = zero_to_one;

 float final_r;
 float final_g;
 float final_b;

 float d_r = c2.r - c1.r;
 float d_g = c2.g - c1.g;
 float d_b = c2.b - c1.b;

 // for(i=0; i<flags.pingpong; i++) { zto = FR_fold_gradient(zto); }

 // There's a weird rounding error this 0.99 fixes. Normally it'd be 1.0
 //
 if(zto >= 1.0) { zto = 0.99; }
 if(zto < 0.0)  { zto = 0.0;  }


 // b_factor comes out a little worse for wear after being
 // folded. Sometimes 13.0000, sometimes 12.99999. Add and round
 // to eliminate this effect.
 //
 if(banding > 1) {
     b_factor = (zto * banding) + 0.01;
     b_factor = floor(b_factor);

     final_r  = c1.r + (d_r / banding) * (float)b_factor;
     final_g  = c1.g + (d_g / banding) * (float)b_factor;
     final_b  = c1.b + (d_b / banding) * (float)b_factor;

     value.r = (int)final_r;
     value.g = (int)final_g;
     value.b = (int)final_b;
     value.a = (int)255;
                 }

 // No banding = smooth gradient
 //
 else {
     final_r = c1.r + (d_r * zto);
     final_g = c1.g + (d_g * zto);
     final_b = c1.b + (d_b * zto);

     value.r = (int)final_r;
     value.g = (int)final_g;
     value.b = (int)final_b;
     value.a = (int)255;
      }

 return(value);
}





bool compare_color(Color one, Color two)
{
 if(one.r == two.r &&
    one.b == two.b &&
    one.g == two.g) { return(1); }

 return(0);
}





// NOTE: Checks two floats and returns 1 if they are within range
//
int check_floats(float one, float two, float range)
{

 float check = fabs(one - two);

 if(check <= range) { return(1); }

 return(0);
}




// NOTE: Checks against a known actor (puppet, lamp, etc)
//       and returns TRUE if they are within ? units of each other.
//
int check_collision(int who, int target, int radius, int z_adjust)
{

 if(who < 0 || who >= MAX_ACTORS) { log(LOG_ALWAYS, "ERROR: Who OOB in %s", __func__); return(0); }
 if(target < 0 || target >= MAX_ACTORS) { log(LOG_ALWAYS, "ERROR: Target OOB in %s", __func__); return(0); }

 int dist = abs(dist_2d(actors[who].pos.x, (actors[who].pos.y - actors[who].pos.z),
                       actors[target].pos.x, (actors[target].pos.y - actors[target].pos.z - z_adjust)));

 if(dist < radius) { return(1); }
 else              { return(0); }
}




// NOTE: Checks collision within a rectangular area.
//       Returns 1 if the actor impinges on this area. Returns 0 if the area is clear.
//
// NOTE: Use the diam_ parameters to establish an area around the actor's "feet"
//
bool check_rect_collision(float check_x, float check_y, int x, int y, int w, int h, int diam_x, int diam_y)
{
 Rectangle _actor  = { 0.0, 0.0, 0.0, 0.0 };
 Rectangle bounds = { (float)x, (float)y, (float)w, (float)h };

 _actor.x      = check_x - (diam_x / 2);
 _actor.y      = check_y - (diam_y / 2);
 _actor.width  = diam_x;
 _actor.height = diam_y;

 return(CheckCollisionRecs(_actor, bounds));
/*
 // Raylib's CheckCollisionRecs is apparently borked as all fuck in v4.5
 // do this instead
 //
 float diff_x = (_actor.width  / 2.0) + (bounds.width  / 2.0);
 float diff_y = (_actor.height / 2.0) + (bounds.height / 2.0);

 //printf("%f, %f, %f, %f\n", abs(check_x - (x + (w/2))), abs(check_y - (y + (h/2))), diff_x, diff_y);
 if(abs(check_x - (x + (w/2))) < diff_x &&
    abs(check_y - (y + (h/2))) < diff_y) { return(1); }
*/
 return(0);
}




// OLD CODE IS OLD.
//
int dist_2d(int x1, int y1, int x2, int y2)
{
 double d_x, d_y;
 double distance;

 d_x = x1 - x2;
 d_y = y1 - y2;

 d_x *= d_x;
 d_y *= d_y;

 distance = sqrt((d_x + d_y));

 return((int)distance);
}





float actor_distance(int actor_1, int actor_2)
{
 double d_x, d_y;
 double distance;

 d_x = actors[actor_1].pos.x - actors[actor_2].pos.x;
 d_y = actors[actor_1].pos.y - actors[actor_2].pos.y;

 d_x *= d_x;
 d_y *= d_y;

 distance = sqrt((d_x + d_y));

 return((float)distance);
}





// NOTE: Justifies text to the center of the screen
//
void justify_text(const char *text, float y, Font font, Color color, float scale, float spacing)
{
 float txt_x = 0;
 Vector2 len = { 0 };

 len   = MeasureTextEx(font, text, (font.baseSize * scale), spacing);
 txt_x = (SCREEN_W / 2) - (int)(len.x / 2.0);

 DrawTextEx(font, text, (Vector2){txt_x, y}, font.baseSize * scale, spacing, color);

 return;
}




// NOTE: Justifies text to an arbitrary set of x/y coordinates
//
void justify_text_xy(const char *text, float x, float y, Font font, Color color, int scale, int spacing)
{
 float txt_x = 0;
 Vector2 len = { 0 };

 len   = MeasureTextEx(font, text, (font.baseSize * scale), spacing);
 txt_x = x - (int)(len.x / 2.0);

 DrawTextEx(font, text, (Vector2){txt_x, y}, font.baseSize * scale, spacing, color);

 return;
}



// NOTE: Right justification
//
void justify_text_r(const char *text, float x, float y, Font font, Color color, int scale, int spacing)
{
 float txt_x = 0;
 Vector2 len = { 0 };

 len   = MeasureTextEx(font, text, (font.baseSize * scale), spacing);
 txt_x = x - len.x;

 DrawTextEx(font, text, (Vector2){txt_x, y}, font.baseSize * scale, spacing, color);

 return;
}




// NOTE: Left justification
//       Provided so it meshes with right justification calls
//
void justify_text_l(const char *text, float x, float y, Font font, Color color, int scale, int spacing)
{

 DrawTextEx(font, text, (Vector2){x, y}, font.baseSize * scale, spacing, color);

 return;
}




// NOTE: Shadowed, justified text at an arbitrary set of x/y coordinates
//
void shadow_text_xy(const char *text, float x, float y, Font font, Color color, Color shadow, int shadow_x, int shadow_y, int scale, int spacing)
{
 float txt_x = 0;
 Vector2 len = { 0 };

 len   = MeasureTextEx(font, text, (font.baseSize * scale), spacing);
 txt_x = x - (int)(len.x / 2.0);

 DrawTextEx(font, text, (Vector2){txt_x + shadow_x, y + shadow_y}, font.baseSize * scale, spacing, shadow);
 DrawTextEx(font, text, (Vector2){txt_x, y}, font.baseSize * scale, spacing, color);

 return;
}





// Vertically-flipped blit.
//
void blit_v(Image src, Image dest, int s_x, int s_y, int d_x, int d_y, int w, int h)
{
 Rectangle s, d;


 s.x = s_x;
 s.y = s_y;
 s.width  = w;
 s.height = h;

 d.x = d_x;
 d.y = d_y;
 d.width  = w;
 d.height = h;

 Image subs = ImageFromImage(src, s);
 ImageFlipVertical(&subs);

 s.x = 0;
 s.y = 0;
 ImageDraw(&dest, subs, s, d, WHITE);

 UnloadImage(subs);

 return;
}




// Horizontally-flipped blit.
//
void blit_h(Image src, Image dest, int s_x, int s_y, int d_x, int d_y, int w, int h)
{
 Rectangle s, d;


 s.x = s_x;
 s.y = s_y;
 s.width  = w;
 s.height = h;

 d.x = d_x;
 d.y = d_y;
 d.width  = w;
 d.height = h;

 Image subs = ImageFromImage(src, s);
 ImageFlipHorizontal(&subs);

 s.x = 0;
 s.y = 0;
 ImageDraw(&dest, subs, s, d, WHITE);

 UnloadImage(subs);

 return;
}





// NOTE: Allegro-style CPU blitting operation
//
void blit(Image src, Image dest, int s_x, int s_y, int d_x, int d_y, int w, int h)
{
 Rectangle s, d;


 s.x = s_x;
 s.y = s_y;
 s.width  = w;
 s.height = h;

 d.x = d_x;
 d.y = d_y;
 d.width  = w;
 d.height = h;

 ImageDraw(&dest, src, s, d, WHITE);

 return;
}




// NOTE: Performs a scaled blit. Fair bit of overhead, so don't abuse.
//
void tex_blit_f(Texture2D tex, int s_x, int s_y, int d_x, int d_y, int w, int h, float scale, float fade)
{
 Rectangle source = { 0 };
 Rectangle dest   = { 0 };
 Vector2 origin   = { 0 };

 push_rect(&source, s_x, s_y, w, h);
 push_rect(&dest, d_x, d_y, w * scale, h * scale);

 DrawTexturePro(tex, source, dest, origin, 0.0, Fade(WHITE, fade));

 return;
}





void tex_blit_c(Texture2D tex, int s_x, int s_y, int d_x, int d_y, int w, int h, float scale, Color col)
{
 Rectangle source = { 0 };
 Rectangle dest   = { 0 };
 Vector2 origin   = { 0 };

 push_rect(&source, s_x, s_y, w, h);
 push_rect(&dest, d_x, d_y, w * scale, h * scale);

 DrawTexturePro(tex, source, dest, origin, 0.0, col);

 return;
}





void tex_blit_h(Texture2D tex, int s_x, int s_y, int d_x, int d_y, int w, int h, float scale, Color col)
{
 Rectangle source = { 0 };
 Rectangle dest   = { 0 };
 Vector2 origin   = { 0 };

 push_rect(&source, s_x, s_y, -w, h);
 push_rect(&dest, d_x, d_y, w * scale, h * scale);

 DrawTexturePro(tex, source, dest, origin, 0.0, col);

 return;
}




void tex_blit(Texture2D tex, int s_x, int s_y, int d_x, int d_y, int w, int h, float rotation, float scale, Color col)
{
 Rectangle source = { 0 };
 Rectangle dest   = { 0 };
 Vector2 origin   = { ((w / 2) * scale), ((h / 2) * scale) };

 push_rect(&source, s_x, s_y, w, h);
 push_rect(&dest, d_x, d_y, w * scale, h * scale);

 DrawTexturePro(tex, source, dest, origin, rotation, col);

 return;
}


/// ----------------------------------------
/// SORTING



// NOTE: OLD CODE IS OLD. Quicksort. Does what it says, says what it does.
//
void quicksort(int low, int high)
{
 int top    = low;
 int bottom = (high - 1);
 int part_index;
 int part_value;

 if (low < high) {

     // Check if elements are sequential
     //
     if(high == (low + 1)) {
         if(sorted[low][0] > sorted[high][0]) { swap_int(high, low, 0); }
                           }

     else {
         // Choose a partition element and swap it with
         // the last value in the array
         //
         part_index = (int)((low + high) / 2);
         part_value = sorted[part_index][0];
         swap_int(high, part_index, 0);

         do {
	         // Inrement the top pointer
             //
	         while((sorted[top][0] <= part_value) && (top <= bottom)) { top++; }

	         // Decrement the bottom pointer
             //
	         while((sorted[bottom][0] > part_value) && (top <= bottom)) { bottom--; }

             // Swap elements if pointers have not met
             //
	         if(top < bottom) { swap_int(top, bottom, 0); }
            } while(top < bottom);

     swap_int(top, high, 0);

     // Recursive calls
     //
     quicksort(low, top - 1);
     quicksort(top + 1, high);
          }

                 }

 return;
}






// NOTE: OLD CODE IS OLD. For use with quicksort implementation
//
void swap_int(int n1, int n2, int index)
{
 int temp;
 int temp2;

 temp  = sorted[n1][0];
 temp2 = sorted[n1][1];

 sorted[n1][0] = sorted[n2][0];
 sorted[n1][1] = sorted[n2][1];

 sorted[n2][0] = temp;
 sorted[n2][1] = temp2;

 return;
}





// Returns a slot to a free actor.
// If something goes wrong, we will clobber actor 0.
// Do something more graceful later
//
// NOTE: mode zero is search from START
//       mode one is search from END
//
int get_free_actor(int mode)
{
 int i = 0;

 if(!mode) {
     for(i=1; i<MAX_ACTORS; i++) {
         if(!actors[i].enabled) { return(i); }
                                 }
           }

 else {
     for(i=MAX_ACTORS-1; i>0; i--) {
         if(!actors[i].enabled) { return(i); }
                                   }
      }

 return(0);
}





int get_population(int team)
{
 int i = 0;
 int total = 0;

 for(i=1; i<MAX_ACTORS; i++) {
     if(actors[i].enabled) {
         if(actors[i].team == team) { total++; }
                           }
                             }

 return(total);
}




int get_radial_population(int who, int radius, int team)
{
 int i     = 0;
 int dist  = 0;
 int total = 0;

 for(i=0; i<MAX_ACTORS; i++) {
     if(actors[i].enabled && i != who) {
         if(actors[i].team == team) {
         dist = dist_2d(actors[who].pos.x, actors[who].pos.y, actors[i].pos.x, actors[i].pos.y);
         if(dist <= radius) { total++; }
                                    }
                                       }
                             }

 return(total);
}






// NOTE: We don't have enough animations to justify external resources.
//       Just be lazy and define them here
//
// NOTE: Zero represents no animation. So leave that slot blank
//
void generate_animations()
{
 int i = 0;


 // Vampimp gun shot
 //
 i = 1;

 anim[i].total_frames = 4;

 anim[i].frame_x[0] = 3;
 anim[i].frame_y[0] = 0;
 anim[i].timing[0]  = 15;

 anim[i].frame_x[1] = 2;
 anim[i].frame_y[1] = 0;
 anim[i].timing[1]  = 10;

 anim[i].frame_x[2] = 1;
 anim[i].frame_y[2] = 0;
 anim[i].timing[2]  = 10;

 anim[i].frame_x[3] = 0;
 anim[i].frame_y[3] = 0;
 anim[i].timing[3]  = 10;



 // Psychocat psyonic attack
 //
 i = 2;

 anim[i].total_frames = 4;

 anim[i].frame_x[0] = 6;
 anim[i].frame_y[0] = 1;
 anim[i].timing[0]  = 15;

 anim[i].frame_x[1] = 6;
 anim[i].frame_y[1] = 1;
 anim[i].timing[1]  = 10;

 anim[i].frame_x[2] = 7;
 anim[i].frame_y[2] = 1;
 anim[i].timing[2]  = 10;

 anim[i].frame_x[3] = 5;
 anim[i].frame_y[3] = 1;
 anim[i].timing[3]  = 10;



 // Luvbot Shotgun blast
 //
 i = 3;

 anim[i].total_frames = 4;

 anim[i].frame_x[0] = 3;
 anim[i].frame_y[0] = 1;
 anim[i].timing[0]  = 15;

 anim[i].frame_x[1] = 2;
 anim[i].frame_y[1] = 1;
 anim[i].timing[1]  = 10;

 anim[i].frame_x[2] = 1;
 anim[i].frame_y[2] = 1;
 anim[i].timing[2]  = 10;

 anim[i].frame_x[3] = 0;
 anim[i].frame_y[3] = 1;
 anim[i].timing[3]  = 10;



 // Siren Invocation
 //
 i = 4;

 anim[i].total_frames = 4;

 anim[i].frame_x[0] = 8;
 anim[i].frame_y[0] = 0;
 anim[i].timing[0]  = 15;

 anim[i].frame_x[1] = 7;
 anim[i].frame_y[1] = 0;
 anim[i].timing[1]  = 10;

 anim[i].frame_x[2] = 6;
 anim[i].frame_y[2] = 0;
 anim[i].timing[2]  = 10;

 anim[i].frame_x[3] = 5;
 anim[i].frame_y[3] = 0;
 anim[i].timing[3]  = 10;




 // Grunt Gun Shot
 //
 i = 5;

 anim[i].total_frames = 4;

 anim[i].frame_x[0] = 13;
 anim[i].frame_y[0] = 0;
 anim[i].timing[0]  = 15;

 anim[i].frame_x[1] = 12;
 anim[i].frame_y[1] = 0;
 anim[i].timing[1]  = 10;

 anim[i].frame_x[2] = 11;
 anim[i].frame_y[2] = 0;
 anim[i].timing[2]  = 10;

 anim[i].frame_x[3] = 10;
 anim[i].frame_y[3] = 0;
 anim[i].timing[3]  = 10;



 // GuardBot Blast
 //
 i = 6;

 anim[i].total_frames = 4;

 anim[i].frame_x[0] = 13;
 anim[i].frame_y[0] = 1;
 anim[i].timing[0]  = 15;

 anim[i].frame_x[1] = 12;
 anim[i].frame_y[1] = 1;
 anim[i].timing[1]  = 10;

 anim[i].frame_x[2] = 11;
 anim[i].frame_y[2] = 1;
 anim[i].timing[2]  = 10;

 anim[i].frame_x[3] = 10;
 anim[i].frame_y[3] = 1;
 anim[i].timing[3]  = 10;



 // Inquisitor Invocation
 //
 i = 7;

 anim[i].total_frames = 4;

 anim[i].frame_x[0] = 18;
 anim[i].frame_y[0] = 0;
 anim[i].timing[0]  = 15;

 anim[i].frame_x[1] = 17;
 anim[i].frame_y[1] = 0;
 anim[i].timing[1]  = 10;

 anim[i].frame_x[2] = 16;
 anim[i].frame_y[2] = 0;
 anim[i].timing[2]  = 10;

 anim[i].frame_x[3] = 15;
 anim[i].frame_y[3] = 0;
 anim[i].timing[3]  = 10;



 // Shield Bearer Shot
 //
 i = 8;

 anim[i].total_frames = 4;

 anim[i].frame_x[0] = 18;
 anim[i].frame_y[0] = 1;
 anim[i].timing[0]  = 15;

 anim[i].frame_x[1] = 17;
 anim[i].frame_y[1] = 1;
 anim[i].timing[1]  = 10;

 anim[i].frame_x[2] = 16;
 anim[i].frame_y[2] = 1;
 anim[i].timing[2]  = 10;

 anim[i].frame_x[3] = 15;
 anim[i].frame_y[3] = 1;
 anim[i].timing[3]  = 10;



 // Vampimp victory jump
 //
 i = 11;

 anim[i].total_frames = 5;

 anim[i].frame_x[0] = 0;
 anim[i].frame_y[0] = 0;
 anim[i].timing[0]  = 0;

 anim[i].frame_x[1] = 0;
 anim[i].frame_y[1] = 2;
 anim[i].timing[1]  = 8;

 anim[i].frame_x[2] = 1;
 anim[i].frame_y[2] = 2;
 anim[i].timing[2]  = 25;

 anim[i].frame_x[3] = 0;
 anim[i].frame_y[3] = 2;
 anim[i].timing[3]  = 10;

 anim[i].frame_x[4] = 0;
 anim[i].frame_y[4] = 0;
 anim[i].timing[4]  = 10;



 // PsychoCat victory jump
 //
 i = 12;

 anim[i].total_frames = 5;

 anim[i].frame_x[0] = 5;
 anim[i].frame_y[0] = 1;
 anim[i].timing[0]  = 0;

 anim[i].frame_x[1] = 5;
 anim[i].frame_y[1] = 3;
 anim[i].timing[1]  = 8;

 anim[i].frame_x[2] = 6;
 anim[i].frame_y[2] = 3;
 anim[i].timing[2]  = 25;

 anim[i].frame_x[3] = 5;
 anim[i].frame_y[3] = 3;
 anim[i].timing[3]  = 10;

 anim[i].frame_x[4] = 5;
 anim[i].frame_y[4] = 1;
 anim[i].timing[4]  = 10;



 // LuvBot victory jump
 //
 i = 13;

 anim[i].total_frames = 5;

 anim[i].frame_x[0] = 0;
 anim[i].frame_y[0] = 1;
 anim[i].timing[0]  = 0;

 anim[i].frame_x[1] = 0;
 anim[i].frame_y[1] = 3;
 anim[i].timing[1]  = 8;

 anim[i].frame_x[2] = 1;
 anim[i].frame_y[2] = 3;
 anim[i].timing[2]  = 25;

 anim[i].frame_x[3] = 0;
 anim[i].frame_y[3] = 3;
 anim[i].timing[3]  = 10;

 anim[i].frame_x[4] = 0;
 anim[i].frame_y[4] = 1;
 anim[i].timing[4]  = 10;



 // Siren victory jump
 //
 i = 14;

 anim[i].total_frames = 5;

 anim[i].frame_x[0] = 5;
 anim[i].frame_y[0] = 0;
 anim[i].timing[0]  = 0;

 anim[i].frame_x[1] = 5;
 anim[i].frame_y[1] = 2;
 anim[i].timing[1]  = 8;

 anim[i].frame_x[2] = 6;
 anim[i].frame_y[2] = 2;
 anim[i].timing[2]  = 25;

 anim[i].frame_x[3] = 5;
 anim[i].frame_y[3] = 2;
 anim[i].timing[3]  = 10;

 anim[i].frame_x[4] = 5;
 anim[i].frame_y[4] = 0;
 anim[i].timing[4]  = 10;

 return;
}





void assign_animation(int who, int anim, int loops)
{
 // Sanity Check
 //
 if(who < 0 || who >= MAX_ACTORS) { return; }

 actors[who].anim_set    = anim;
 actors[who].anim_step   = 0;
 actors[who].anim_timing = 0;
 actors[who].anim_loop   = loops;

 return;
}





void kill_animation(int who)
{
 // Sanity Check
 //
 if(who < 0 || who >= MAX_ACTORS) { return; }

 actors[who].anim_set    = 0;
 actors[who].anim_step   = 0;
 actors[who].anim_timing = 0;
 actors[who].anim_loop   = 0;

 return;
}






// NOTE: Gets rough, cardinal direction between two actors (0-3 = UP, DOWN, LEFT, RIGHT)
//
int get_rough_dir(int x1, int y1, int x2, int y2)
{
 float angle = get_angle_between(x1, y1, x2, y2);

 if(angle >= 45 && angle < 135) { return(3); }
 if(angle >= 135 && angle < 225) { return(1); }
 if(angle >= 225 && angle < 315) { return(2); }
 if(angle >= 315 || angle < 45)  { return(0); }

 return(-1); // Something went wrong and the universe shat itself. I dunno.

}





float get_angle_between(float x1, float y1, float x2, float y2)
{
 float angle = 0;
 float x_diff, y_diff;


 x_diff = (x2 - x1);
 y_diff = (y2 - y1);

 angle = atan2(y_diff, x_diff);
 angle *= (180.00 / M_PI);


 // This produces an angle where the zero point is facing dead left <---
 // So correct this by adding 90 degrees.
 //
 angle += 90.00;


 // Correct the Radians/angle snafu by adding 360 to the total if the result is negative
 // Otherwise you go from 180 to -180 in the middle of your circle. Boo! Hiss!
 //
 if(angle < 0) { angle += 360.00; }

 return(angle);
}




// NOTE: Pass -1 to not modify volume or pitch
//
void set_sound(int slot, float pitch, float volume)
{

 if(slot < 0 || slot > MAX_SFX) { log(LOG_ALWAYS, "Slot %d OOB in %s", slot, __func__); return; }

 if(volume > 0.0) { SetSoundVolume(sfx[slot], volume); }
 if(pitch  > 0.0) { SetSoundPitch(sfx[slot],  pitch);  }

 return;
}





// Draw part of a texture (defined by a rectangle) with rotation and scale tiled into dest.
// This was lifted from the Raylib example (as recommended by the maintainer) as it has been
// removed from the library for some reason.
//
void DrawTextureTiled(Texture2D texture, Rectangle source, Rectangle dest, Vector2 origin, float rotation, float scale, Color tint)
{
    if ((texture.id <= 0) || (scale <= 0.0f)) return;  // Wanna see a infinite loop?!...just delete this line!
    if ((source.width == 0) || (source.height == 0)) return;

    int tileWidth = (int)(source.width*scale), tileHeight = (int)(source.height*scale);
    if ((dest.width < tileWidth) && (dest.height < tileHeight))
    {
        // Can fit only one tile
        DrawTexturePro(texture, (Rectangle){source.x, source.y, ((float)dest.width/tileWidth)*source.width, ((float)dest.height/tileHeight)*source.height},
                    (Rectangle){dest.x, dest.y, dest.width, dest.height}, origin, rotation, tint);
    }
    else if (dest.width <= tileWidth)
    {
        // Tiled vertically (one column)
        int dy = 0;
        for (;dy+tileHeight < dest.height; dy += tileHeight)
        {
            DrawTexturePro(texture, (Rectangle){source.x, source.y, ((float)dest.width/tileWidth)*source.width, source.height}, (Rectangle){dest.x, dest.y + dy, dest.width, (float)tileHeight}, origin, rotation, tint);
        }

        // Fit last tile
        if (dy < dest.height)
        {
            DrawTexturePro(texture, (Rectangle){source.x, source.y, ((float)dest.width/tileWidth)*source.width, ((float)(dest.height - dy)/tileHeight)*source.height},
                        (Rectangle){dest.x, dest.y + dy, dest.width, dest.height - dy}, origin, rotation, tint);
        }
    }
    else if (dest.height <= tileHeight)
    {
        // Tiled horizontally (one row)
        int dx = 0;
        for (;dx+tileWidth < dest.width; dx += tileWidth)
        {
            DrawTexturePro(texture, (Rectangle){source.x, source.y, source.width, ((float)dest.height/tileHeight)*source.height}, (Rectangle){dest.x + dx, dest.y, (float)tileWidth, dest.height}, origin, rotation, tint);
        }

        // Fit last tile
        if (dx < dest.width)
        {
            DrawTexturePro(texture, (Rectangle){source.x, source.y, ((float)(dest.width - dx)/tileWidth)*source.width, ((float)dest.height/tileHeight)*source.height},
                        (Rectangle){dest.x + dx, dest.y, dest.width - dx, dest.height}, origin, rotation, tint);
        }
    }
    else
    {
        // Tiled both horizontally and vertically (rows and columns)
        int dx = 0;
        for (;dx+tileWidth < dest.width; dx += tileWidth)
        {
            int dy = 0;
            for (;dy+tileHeight < dest.height; dy += tileHeight)
            {
                DrawTexturePro(texture, source, (Rectangle){dest.x + dx, dest.y + dy, (float)tileWidth, (float)tileHeight}, origin, rotation, tint);
            }

            if (dy < dest.height)
            {
                DrawTexturePro(texture, (Rectangle){source.x, source.y, source.width, ((float)(dest.height - dy)/tileHeight)*source.height},
                    (Rectangle){dest.x + dx, dest.y + dy, (float)tileWidth, dest.height - dy}, origin, rotation, tint);
            }
        }

        // Fit last column of tiles
        if (dx < dest.width)
        {
            int dy = 0;
            for (;dy+tileHeight < dest.height; dy += tileHeight)
            {
                DrawTexturePro(texture, (Rectangle){source.x, source.y, ((float)(dest.width - dx)/tileWidth)*source.width, source.height},
                        (Rectangle){dest.x + dx, dest.y + dy, dest.width - dx, (float)tileHeight}, origin, rotation, tint);
            }

            // Draw final tile in the bottom right corner
            if (dy < dest.height)
            {
                DrawTexturePro(texture, (Rectangle){source.x, source.y, ((float)(dest.width - dx)/tileWidth)*source.width, ((float)(dest.height - dy)/tileHeight)*source.height},
                    (Rectangle){dest.x + dx, dest.y + dy, dest.width - dx, dest.height - dy}, origin, rotation, tint);
            }
        }
    }
}





Vector2 advance(float angle, float velocity)
{

 Vector2 result = { 0 };

 result.x = sin(degrees_to_radians(angle)) * velocity;
 result.y = -cos(degrees_to_radians(angle)) * velocity;

 return(result);
}



// NOTE: Very similar to sine wave, but with gentler entry and exit,
//       and steeper transition in the middle. Makes a sine wave a
//       tad more squarish.
//
// NOTE: X should be ranged 0-1
//
double easing_cubic(double x)
{
 if (x < 0.5) { return(4.0 * x * x * x);                        }
 else         { return(1.0 - (pow(-2.0 * x + 2.0, 3.0) / 2.0)); }
}




// NOTE: [max_time] is the number of total game ticks to display the signal
//       Fade ranges are 0-1, and represent a portion of the max-time to fade in/out
//
void trigger_signal(int signal, int max_time, float fade_in_range, float fade_out_range)
{

 flags.show_signal     = signal;
 flags.signal_time     = 0;
 flags.signal_max_time = max_time;

 flags.signal_f_in  = rescale(fade_in_range,  0.0, 1.0, 0, max_time);
 flags.signal_f_out = rescale(fade_out_range, 0.0, 1.0, 0, max_time);

 return;
}






#ifdef USE_HIGH_SCORE
void write_high_score()
{
 FILE *handle = NULL;

 handle = fopen("user.dat", "wb");

 if(handle == NULL) { return; }

 fputc(hi_score.initials[0], handle);
 fputc(hi_score.initials[1], handle);
 fputc(hi_score.initials[2], handle);

 write_32bit_int(handle, flags.score[0]);

 fclose(handle);

 return;
}






int read_high_score()
{
 FILE *handle = NULL;

 handle = fopen("user.dat", "rb");

 if(handle == NULL) {
     // report missing or damaged high score file
     // Assume default values
     //
     return(0);
                    }

 high_init[0] = fgetc(handle);
 high_init[1] = fgetc(handle);
 high_init[2] = fgetc(handle);
 high_init[3] = 0; // Make sure this is terminated, no matter what we read

 flags.high_score = read_32bit_value(handle);

 fclose(handle);

 return(1);
}





void write_32bit_int(FILE *handle, int value)
{
 if(handle == NULL) { return; }

 fputc((value & 0xFF000000) >> 24, handle);
 fputc((value & 0x00FF0000) >> 16, handle);
 fputc((value & 0x0000FF00) >> 8, handle);
 fputc((value & 0x000000FF), handle);

 return;
}





int read_32bit_value(FILE *handle)
{
 int value = 0;

 if(handle == NULL) { return(0); }

 value += fgetc(handle) << 24;
 value += fgetc(handle) << 16;
 value += fgetc(handle) << 8;
 value += fgetc(handle);

 return(value);
}




// Out of laziness, check each key and send back anything unique
// Valid keys are A-Z and 0-9. Returns 0 if no button seen
//
int get_initial()
{
 int check = 0;

 if(IsKeyPressed(KEY_A)) { return(65); }

 if(IsKeyPressed(KEY_B))  { return(66); }
 if(IsKeyPressed(KEY_C))  { return(67); }
 if(IsKeyPressed(KEY_D))  { return(68); }
 if(IsKeyPressed(KEY_E))  { return(69); }
 if(IsKeyPressed(KEY_F))  { return(70); }
 if(IsKeyPressed(KEY_G))  { return(71); }

 if(IsKeyPressed(KEY_H))  { return(72); }
 if(IsKeyPressed(KEY_I))  { return(73); }
 if(IsKeyPressed(KEY_J))  { return(74); }
 if(IsKeyPressed(KEY_K))  { return(75); }
 if(IsKeyPressed(KEY_L))  { return(76); }
 if(IsKeyPressed(KEY_M))  { return(77); }
 if(IsKeyPressed(KEY_N))  { return(78); }
 if(IsKeyPressed(KEY_O))  { return(79); }
 if(IsKeyPressed(KEY_P))  { return(80); }

 if(IsKeyPressed(KEY_Q))  { return(81); }
 if(IsKeyPressed(KEY_R))  { return(82); }
 if(IsKeyPressed(KEY_S))  { return(83); }
 if(IsKeyPressed(KEY_T))  { return(84); }
 if(IsKeyPressed(KEY_U))  { return(85); }
 if(IsKeyPressed(KEY_V))  { return(86); }
 if(IsKeyPressed(KEY_W))  { return(87); }
 if(IsKeyPressed(KEY_X))  { return(88); }
 if(IsKeyPressed(KEY_Y))  { return(89); }
 if(IsKeyPressed(KEY_Z))  { return(90); }

 if(IsKeyPressed(KEY_ZERO))  { return(48); }
 if(IsKeyPressed(KEY_ONE))   { return(49); }
 if(IsKeyPressed(KEY_TWO))   { return(50); }
 if(IsKeyPressed(KEY_THREE)) { return(51); }
 if(IsKeyPressed(KEY_FOUR))  { return(52); }
 if(IsKeyPressed(KEY_FIVE))  { return(53); }
 if(IsKeyPressed(KEY_SIX))   { return(54); }
 if(IsKeyPressed(KEY_SEVEN)) { return(55); }
 if(IsKeyPressed(KEY_EIGHT)) { return(56); }
 if(IsKeyPressed(KEY_NINE))  { return(57); }

 return(check);
}


#endif
